# Add project specific ProGuard rules here.
# You can control the set of applied configuration files using the
# proguardFiles setting in build.gradle.
#
# For more details, see
#   http://developer.android.com/guide/developing/tools/proguard.html

# Uncomment this to preserve the line number information for
# debugging stack traces.
-keepattributes SourceFile,LineNumberTable

# If you keep the line number information, uncomment this to
# hide the original source file name.
-renamesourcefileattribute SourceFile

-verbose

#---------------Begin: proguard configuration to strip logging  ---------
-assumenosideeffects class com.ibm.gbs.va.grit.util.RemoteLog {
    public static void v(...);
    public static void d(...);
}
-assumenosideeffects class android.util.Log {
    public static boolean isLoggable(java.lang.String, int);
    public static int v(...);
    public static int d(...);
}
##---------------End: proguard configuration to strip logging  ----------


#---------------Begin: proguard configuration for Chatkit  ---------
-keep class * extends com.stfalcon.chatkit.messages.MessageHolders$BaseIncomingMessageViewHolder {
    public <init>(android.view.View, java.lang.Object);
    public <init>(android.view.View);
 }
-keep class * extends com.stfalcon.chatkit.messages.MessageHolders$BaseMessageViewHolder {
    public <init>(android.view.View, java.lang.Object);
    public <init>(android.view.View);
  }
##---------------End: proguard configuration for Chatkit  ----------


#---------------Begin: proguard configuration for Retrofit  ---------
# Retrofit does reflection on generic parameters. InnerClasses is required to use Signature and
# EnclosingMethod is required to use InnerClasses.
-keepattributes Signature, InnerClasses, EnclosingMethod
# Retain service method parameters when optimizing.
-keepclassmembers, allowshrinking, allowobfuscation interface * {
    @retrofit2.http.* <methods>;
}
# Ignore JSR 305 annotations for embedding nullability information.
-dontwarn javax.annotation.**
# A resource is loaded with a relative path so the package of this class must be preserved.
-keepnames class okhttp3.internal.publicsuffix.PublicSuffixDatabase
# Animal Sniffer compileOnly dependency to ensure APIs are compatible with older versions of Java.
-dontwarn org.codehaus.mojo.animal_sniffer.*
# OkHttp platform used only on JVM and when Conscrypt dependency is available.
-dontwarn okhttp3.internal.platform.ConscryptPlatform
##---------------End: proguard configuration for Retrofit  ----------


#---------------Begin: proguard configuration for Room  ---------
-keep class net.sqlcipher.** { *; }
-dontwarn net.sqlcipher.**
##---------------End: proguard configuration for Room  ----------


#---------------Begin: proguard configuration for Gson  ---------
# Gson uses generic type information stored in a class file when working with fields. Proguard
# removes such information by default, so configure it to keep all of it.
-keepattributes Signature
# For using GSON @Expose annotation
-keepattributes *Annotation*
# Gson specific classes
-dontwarn sun.misc.**
# Application classes that will be serialized/deserialized over Gson
-keep class com.ibm.gbs.va.grit.model.** { *; }
-keep class com.ibm.gbs.va.grit.room.TypeConverters { *; }
-keep enum com.ibm.gbs.va.grit.model.** { *; }
-keep enum com.ibm.gbs.va.grit.model.survey.Question$QuestionType { *; }
# Prevent proguard from stripping interface information from TypeAdapterFactory,
# JsonSerializer, JsonDeserializer instances (so they can be used in @JsonAdapter)
-keep class * implements com.google.gson.TypeAdapterFactory
-keep class * implements com.google.gson.JsonSerializer
-keep class * implements com.google.gson.JsonDeserializer
##---------------End: proguard configuration for Gson  ----------