package com.ibm.gbs.va.grit.adapter;

import android.support.annotation.NonNull;
import android.support.v7.widget.RecyclerView;

import com.ibm.gbs.va.grit.databinding.CardDashboardMessageBinding;
import com.ibm.gbs.va.grit.model.notifications.Notification;

import static com.ibm.gbs.va.grit.adapter.DashboardMessagePagerAdapter.OnMessageClickedDelegate;

public class NotificationViewHolder extends RecyclerView.ViewHolder {
    private final OnMessageClickedDelegate delegate;
    private final CardDashboardMessageBinding binding;

    public NotificationViewHolder(@NonNull CardDashboardMessageBinding binding, OnMessageClickedDelegate delegate) {
        super(binding.getRoot());
        this.binding = binding;
        this.delegate = delegate;
    }

    public void bindNotification(Notification notification) {
        binding.setModel(notification);
        binding.card.setOnClickListener(view -> delegate.onMessageClicked(notification));
    }
}
