package com.ibm.gbs.va.grit.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import java.util.List;

import androidx.annotation.LayoutRes;
import androidx.annotation.NonNull;

public class SelectedSpinnerAdapter<T> extends ArrayAdapter<T> {

    private final LayoutInflater layoutInflater;

    private int currentSelectedIndex = -1;
    @LayoutRes
    private int selectedDropdownLayoutID = -1;

    public SelectedSpinnerAdapter(@NonNull Context context, int resource, @NonNull List<T> objects) {
        super(context, resource, objects);
        layoutInflater = LayoutInflater.from(context);
    }

    @Override
    public View getDropDownView(int position, View convertView, @android.support.annotation.NonNull ViewGroup parent) {
        convertView = null;

        if (position == currentSelectedIndex) {
            if (selectedDropdownLayoutID != -1) {
                convertView = layoutInflater.inflate(selectedDropdownLayoutID, parent, false);
                TextView text = (TextView) convertView;
                final T item = getItem(position);
                if (item instanceof CharSequence) {
                    text.setText((CharSequence) item);
                } else {
                    text.setText(item.toString());
                }
            } else {
                convertView = super.getDropDownView(position, convertView, parent);
            }
        } else {
            convertView = super.getDropDownView(position, convertView, parent);
        }

        return convertView;
    }

    public int getCurrentSelectedIndex() {
        return currentSelectedIndex;
    }

    public void setCurrentSelectedIndex(int currentSelectedIndex) {
        this.currentSelectedIndex = currentSelectedIndex;
        notifyDataSetChanged();
    }

    public void setSelectedDropdownLayoutID(@LayoutRes int selectedLayout) {
        selectedDropdownLayoutID = selectedLayout;
    }


}
