package com.ibm.gbs.va.grit.dagger;

import com.ibm.gbs.va.grit.activity.AuthenticationActivity;
import com.ibm.gbs.va.grit.activity.DashboardActivity;
import com.ibm.gbs.va.grit.activity.MainActivity;
import com.ibm.gbs.va.grit.activity.SurveyActivity;
import com.ibm.gbs.va.grit.activity.WalkthroughActivity;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import javax.inject.Scope;

import dagger.Module;
import dagger.android.ContributesAndroidInjector;

@SuppressWarnings("unused")
@Module
abstract class ActivityContributorModule {

    @Retention(RetentionPolicy.CLASS)
    @Scope
    @interface ActivityScope {
    }

    @ActivityScope
    @ContributesAndroidInjector(modules = {FragmentContributorModule.class})
    abstract DashboardActivity contributeDashboardActivity();

    @ActivityScope
    @ContributesAndroidInjector(modules = {FragmentContributorModule.class})
    abstract AuthenticationActivity contributeEnterAppActivity();

    @ActivityScope
    @ContributesAndroidInjector(modules = {FragmentContributorModule.class})
    abstract MainActivity contributeMainActivity();

    @ActivityScope
    @ContributesAndroidInjector(modules = {FragmentContributorModule.class})
    abstract SurveyActivity contributeSurveyActivity();

    @ActivityScope
    @ContributesAndroidInjector(modules = {FragmentContributorModule.class})
    abstract WalkthroughActivity contributeWalkthroughActivity();

    // add more Activities here
}
