package com.ibm.gbs.va.grit.dagger;

import com.ibm.gbs.va.grit.GritApplication;
import com.ibm.gbs.va.grit.rest.GritCallbackInjectionHelper;
import com.ibm.gbs.va.grit.room.GritDatabase;
import com.ibm.gbs.va.grit.util.Keystore;

import javax.inject.Singleton;

import dagger.BindsInstance;
import dagger.Component;
import dagger.android.AndroidInjector;
import dagger.android.support.AndroidSupportInjectionModule;

@Singleton
@SuppressWarnings("unchecked")
@Component(modules = {AndroidSupportInjectionModule.class, AppModule.class, ActivityContributorModule.class, ViewModelModule.class})
public interface AppComponent extends AndroidInjector<GritApplication> {

    GritDatabase getGritDB();

    Keystore getKeystore();

    void injectGritCallbackHelper(GritCallbackInjectionHelper gritCallback);


    @Component.Builder
    interface Builder {
        @BindsInstance
        Builder application(GritApplication application);

        AppComponent build();
    }
}
