package com.ibm.gbs.va.grit.dagger;

import com.ibm.gbs.va.grit.fragment.NonInteractiveFragment;
import com.ibm.gbs.va.grit.fragment.WalkthroughStepFragment;
import com.ibm.gbs.va.grit.fragment.chat.ChatFragment;
import com.ibm.gbs.va.grit.fragment.dashboard.DashboardFragment;
import com.ibm.gbs.va.grit.fragment.dashboard.ImmediateHelpFragment;
import com.ibm.gbs.va.grit.fragment.dialog.ChangePasswordDialogFragment;
import com.ibm.gbs.va.grit.fragment.dialog.GritDialogFragment;
import com.ibm.gbs.va.grit.fragment.dialog.ResetPasswordDialogFragment;
import com.ibm.gbs.va.grit.fragment.digitalself.BadgeListFragment;
import com.ibm.gbs.va.grit.fragment.digitalself.DigitalJournalFragment;
import com.ibm.gbs.va.grit.fragment.digitalself.DigitalSelfFragment;
import com.ibm.gbs.va.grit.fragment.employment.EmploymentFilterFragment;
import com.ibm.gbs.va.grit.fragment.employment.EmploymentFragment;
import com.ibm.gbs.va.grit.fragment.employment.JobFragment;
import com.ibm.gbs.va.grit.fragment.employment.JobsTabFragment;
import com.ibm.gbs.va.grit.fragment.employment.SavedJobsTabFragment;
import com.ibm.gbs.va.grit.fragment.employment.SkillsTabFragment;
import com.ibm.gbs.va.grit.fragment.login.EnterAppFragment;
import com.ibm.gbs.va.grit.fragment.login.ForgotPasswordFragment;
import com.ibm.gbs.va.grit.fragment.login.LoginFragment;
import com.ibm.gbs.va.grit.fragment.login.PrivacyFragment;
import com.ibm.gbs.va.grit.fragment.login.SignUpFragment;
import com.ibm.gbs.va.grit.fragment.question.ListChoiceSubFragment;
import com.ibm.gbs.va.grit.fragment.question.SliderSubFragment;
import com.ibm.gbs.va.grit.fragment.question.TextEntrySubFragment;
import com.ibm.gbs.va.grit.fragment.settings.EditProfileFragment;
import com.ibm.gbs.va.grit.fragment.settings.PrivacySettingsFragment;
import com.ibm.gbs.va.grit.fragment.settings.SettingsFragment;
import com.ibm.gbs.va.grit.fragment.settings.SocialMediaFragment;
import com.ibm.gbs.va.grit.fragment.squad.AddSquadFragment;
import com.ibm.gbs.va.grit.fragment.squad.SquadFragment;

import dagger.Module;
import dagger.android.ContributesAndroidInjector;

@SuppressWarnings("unused")
@Module
abstract class FragmentContributorModule {

    @ContributesAndroidInjector
    abstract NonInteractiveFragment contributeNonInteractiveFragment();

    @ContributesAndroidInjector
    abstract WalkthroughStepFragment contributeWalkthroughStepFragment();

    @ContributesAndroidInjector
    abstract EnterAppFragment contributeAuthenticateFragment();

    @ContributesAndroidInjector
    abstract LoginFragment contributeLoginFragment();

    @ContributesAndroidInjector
    abstract SignUpFragment contributeSignUpFragment();

    @ContributesAndroidInjector
    abstract PrivacyFragment contributePrivacyFragment();

    @ContributesAndroidInjector
    abstract DashboardFragment contributeDashboardFragment();

    @ContributesAndroidInjector
    abstract ImmediateHelpFragment contributeImmediateHelpFragment();

    @ContributesAndroidInjector
    abstract ListChoiceSubFragment contributeListChoiceSubFragment();

    @ContributesAndroidInjector
    abstract SliderSubFragment contributeSliderSubFragment();

    @ContributesAndroidInjector
    abstract TextEntrySubFragment contributeTextEntrySubFragment();

    @ContributesAndroidInjector
    abstract EditProfileFragment contributeEditProfileFragment();

    @ContributesAndroidInjector
    abstract SettingsFragment contributeSettingsFragment();

    @ContributesAndroidInjector
    abstract PrivacySettingsFragment contributePrivacySettingsFragment();

    @ContributesAndroidInjector
    abstract ChangePasswordDialogFragment contributeChangePasswordDialogFragment();

    @ContributesAndroidInjector
    abstract ResetPasswordDialogFragment contributeResetPasswordDialogFragment();

    @ContributesAndroidInjector
    abstract EmploymentFragment contributeEmploymentFragment();

    @ContributesAndroidInjector
    abstract EmploymentFilterFragment contributeEmploymentFilterFragment();

    @ContributesAndroidInjector
    abstract JobsTabFragment contributeJobsTabFragment();

    @ContributesAndroidInjector
    abstract JobFragment contributeJobFragment();

    @ContributesAndroidInjector
    abstract SavedJobsTabFragment contributeSavedJobsTabFragment();

    @ContributesAndroidInjector
    abstract SkillsTabFragment contributeSkillsFragment();

    @ContributesAndroidInjector
    abstract ChatFragment contributeChatFragment();

    @ContributesAndroidInjector
    abstract GritDialogFragment contributeGritDialogFragment();

    @ContributesAndroidInjector
    abstract SocialMediaFragment contributeSocialMediaFragment();

    @ContributesAndroidInjector
    abstract SquadFragment contributeSquadFragment();

    @ContributesAndroidInjector
    abstract AddSquadFragment contributeAddSquadFragment();

    @ContributesAndroidInjector
    abstract ForgotPasswordFragment contributeForgotPasswordDialogFragment();

    @ContributesAndroidInjector
    abstract DigitalSelfFragment contributesDigitalSelfFragment();

    @ContributesAndroidInjector
    abstract DigitalJournalFragment contributeDigitalJournalFragment();

    @ContributesAndroidInjector
    abstract BadgeListFragment contributesBadgeListFragment();

    // add more Fragments here
}
