package com.ibm.gbs.va.grit.dagger;

import com.ibm.gbs.va.grit.GritApplication;
import com.ibm.gbs.va.grit.repository.AuthorizationRepository;
import com.ibm.gbs.va.grit.repository.ChatRepository;
import com.ibm.gbs.va.grit.repository.DigitalSelfRepository;
import com.ibm.gbs.va.grit.repository.JobRepository;
import com.ibm.gbs.va.grit.repository.NotificationRepository;
import com.ibm.gbs.va.grit.repository.SocialMediaRepository;
import com.ibm.gbs.va.grit.repository.SquadRepository;
import com.ibm.gbs.va.grit.repository.SurveyRepository;
import com.ibm.gbs.va.grit.repository.UserRepository;

import javax.inject.Named;

import dagger.Subcomponent;
import dagger.android.AndroidInjector;
import dagger.android.support.AndroidSupportInjectionModule;

@UserScope
@Subcomponent(modules = {UserModule.class, AndroidSupportInjectionModule.class})
public interface UserComponent extends AndroidInjector<GritApplication> {

    @Named("NewRepo")
    UserRepository getCurrentUserRepo();

    @Named("NewRepo")
    SurveyRepository getCurrentSurveyRepo();

    @Named("NewRepo")
    NotificationRepository getCurrentNotificationRepo();

    @Named("NewRepo")
    JobRepository getCurrentJobRepo();

    @Named("NewRepo")
    ChatRepository getCurrentChatRepo();

    @Named("NewRepo")
    SocialMediaRepository getSocialMediaRepository();

    @Named("NewRepo")
    SquadRepository getSquadRepository();

    @Named("NewRepo")
    AuthorizationRepository getAuthorizationRepository();

    @Named("NewRepo")
    DigitalSelfRepository getDigitalJournalRepository();

    @Subcomponent.Builder
    interface Builder {
        UserComponent build();
    }

}
