package com.ibm.gbs.va.grit.dagger;

import android.arch.lifecycle.ViewModel;
import android.arch.lifecycle.ViewModelProvider;

import com.ibm.gbs.va.grit.viewmodel.BadgeListViewModel;
import com.ibm.gbs.va.grit.viewmodel.ChangePasswordViewModel;
import com.ibm.gbs.va.grit.viewmodel.ChatViewModel;
import com.ibm.gbs.va.grit.viewmodel.DashboardViewModel;
import com.ibm.gbs.va.grit.viewmodel.DigitalJournalViewModel;
import com.ibm.gbs.va.grit.viewmodel.EditProfileViewModel;
import com.ibm.gbs.va.grit.viewmodel.EmploymentViewModel;
import com.ibm.gbs.va.grit.viewmodel.ForgotPasswordViewModel;
import com.ibm.gbs.va.grit.viewmodel.SocialMediaViewModel;
import com.ibm.gbs.va.grit.viewmodel.SquadViewModel;
import com.ibm.gbs.va.grit.viewmodel.SurveyViewModel;
import com.ibm.gbs.va.grit.viewmodel.ViewModelFactory;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import javax.inject.Singleton;

import dagger.Binds;
import dagger.MapKey;
import dagger.Module;
import dagger.multibindings.IntoMap;

@Module
abstract class ViewModelModule {

    @Target({ElementType.METHOD, ElementType.FIELD})
    @Retention(RetentionPolicy.RUNTIME)
    @MapKey
    @interface ViewModelKey {
        @SuppressWarnings("unused") Class<? extends ViewModel> value();
    }

    @Binds
    @Singleton
    abstract ViewModelProvider.Factory bindViewModelFactory(ViewModelFactory factory);

    @Binds
    @IntoMap
    @ViewModelKey(DashboardViewModel.class)
    abstract ViewModel dashboardViewModel(DashboardViewModel viewModel);

    @Binds
    @IntoMap
    @ViewModelKey(EditProfileViewModel.class)
    abstract ViewModel editProfileViewModel(EditProfileViewModel viewModel);

    @Binds
    @IntoMap
    @ViewModelKey(ChangePasswordViewModel.class)
    abstract ViewModel changePasswordViewModel(ChangePasswordViewModel viewModel);

    @Binds
    @IntoMap
    @ViewModelKey(SurveyViewModel.class)
    abstract ViewModel surveyViewModel(SurveyViewModel viewModel);

    @Binds
    @IntoMap
    @ViewModelKey(EmploymentViewModel.class)
    abstract ViewModel employmentFilterViewModel(EmploymentViewModel viewModel);

    @Binds
    @IntoMap
    @ViewModelKey(ChatViewModel.class)
    abstract ViewModel chatViewModel(ChatViewModel viewModel);

    @Binds
    @IntoMap
    @ViewModelKey(SocialMediaViewModel.class)
    abstract ViewModel socialMediaViewModel(SocialMediaViewModel viewModel);

    @Binds
    @IntoMap
    @ViewModelKey(SquadViewModel.class)
    abstract ViewModel squadViewModel(SquadViewModel viewModel);

    @Binds
    @IntoMap
    @ViewModelKey(ForgotPasswordViewModel.class)
    abstract ViewModel forgotPasswordViewModel(ForgotPasswordViewModel viewModel);

    @Binds
    @IntoMap
    @ViewModelKey(DigitalJournalViewModel.class)
    abstract ViewModel digitalJournalViewModel(DigitalJournalViewModel viewModel);

    @Binds
    @IntoMap
    @ViewModelKey(BadgeListViewModel.class)
    abstract ViewModel badgeListViewModel(BadgeListViewModel viewModel);

    // add more View Models here
}
