package com.ibm.gbs.va.grit.fragment;

import android.os.Bundle;
import android.support.annotation.LayoutRes;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.ibm.gbs.va.grit.util.RemoteLog;

import java.util.Objects;

public class NonInteractiveFragment extends AnalyticsFragment {

    @LayoutRes
    private Integer layout = null;

    public static NonInteractiveFragment getInstance(@LayoutRes int layout) {
        NonInteractiveFragment frag = new NonInteractiveFragment();
        frag.layout = layout;
        return frag;
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        TAG = Objects.requireNonNull(getActivity()).getResources().getResourceEntryName(layout);
        if (layout == null) {
            RemoteLog.e(TAG, "Must provide a layout to display");
            return super.onCreateView(inflater, container, savedInstanceState);
        }

        return inflater.inflate(layout, container, false);
    }

}
