package com.ibm.gbs.va.grit.fragment;

import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.ibm.gbs.va.grit.databinding.WalkthroughStepFrameBinding;
import com.ibm.gbs.va.grit.model.type.WalkthroughStep;

public class WalkthroughStepFragment extends AnalyticsFragment {

    private static final String WALKTHROUGH_MODEL_TAG = "walkthroughModel";


    public static WalkthroughStepFragment getInstance(WalkthroughStep model) {
        WalkthroughStepFragment frag = new WalkthroughStepFragment();
        Bundle args = new Bundle();
        Gson gson = new Gson();
        args.putString(WALKTHROUGH_MODEL_TAG, gson.toJson(model));

        frag.setArguments(args);
        return frag;
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        TAG = "WalkthroughStepFragment";
        WalkthroughStepFrameBinding binding = WalkthroughStepFrameBinding.inflate(inflater, container, false);
        assert (getActivity() != null);
        Bundle args = getArguments();
        Gson gson = new Gson();
        WalkthroughStep model = gson.fromJson(args.getString(WALKTHROUGH_MODEL_TAG), new TypeToken<WalkthroughStep>() {
        }.getType());

        binding.setModel(model);

        return binding.getRoot();
    }
}
