package com.ibm.gbs.va.grit.fragment.dialog;

import android.app.AlertDialog;
import android.app.Dialog;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v4.app.DialogFragment;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.TextView;

import com.ibm.gbs.va.grit.R;


public class AlertFragment extends DialogFragment {

    private static final String ARG_MESSAGE = "paramMessage";

    private String mParamMessage;

    public static AlertFragment newInstance(String message) {
        AlertFragment fragment = new AlertFragment();
        Bundle args = new Bundle();
        args.putString(ARG_MESSAGE, message);
        fragment.setArguments(args);
        return fragment;
    }

    @NonNull
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {

        if (getArguments() != null) {
            mParamMessage = getArguments().getString(ARG_MESSAGE);
        }

        //Set up Layout
        View mView = getActivity().getLayoutInflater().inflate(R.layout.alert_dialog, null);

        TextView alertMsgTextView = mView.findViewById(R.id.body);
        alertMsgTextView.setText(mParamMessage);
        Dialog dlg = new AlertDialog.Builder(getActivity())
                .setView(mView)
                .create();

        Window window = dlg.getWindow();
        window.setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        WindowManager.LayoutParams wlp = window.getAttributes();

        wlp.gravity = Gravity.TOP;
        wlp.y = 50;
        window.setAttributes(wlp);

        return dlg;
    }
}
