package com.ibm.gbs.va.grit.fragment.dialog;

import android.app.Dialog;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.FragmentManager;
import android.support.v7.app.AppCompatDialogFragment;
import android.util.DisplayMetrics;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;

import com.ibm.gbs.va.grit.R;
import com.ibm.gbs.va.grit.databinding.DialogCheckEmailBinding;
import com.ibm.gbs.va.grit.util.CompositeOnClickListener;

public class CheckEmailDialogFragment extends AppCompatDialogFragment {
    private final static String TAG = "CheckEmailDialogFragment";
    private DialogCheckEmailBinding binding;

    public static CheckEmailDialogFragment showDialog(FragmentManager fragmentManager, String email, View.OnClickListener onNextClicked, View.OnClickListener onResendClicked) {
        CheckEmailDialogFragment frag = new CheckEmailDialogFragment();
        frag.email = email;
        frag.onNextClicked = onNextClicked;
        frag.onResendClicked = onResendClicked;

        frag.show(fragmentManager, TAG);
        return frag;
    }

    private View.OnClickListener onNextClicked;
    private View.OnClickListener onResendClicked;
    private String email;

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        binding = DialogCheckEmailBinding.inflate(inflater, container, false);
        binding.setLifecycleOwner(this);

        binding.email.setText(email);
        binding.nextBtn.setOnClickListener(new CompositeOnClickListener(v -> dismiss(), onNextClicked));
        binding.resendBtn.setOnClickListener(onResendClicked);

        return binding.getRoot();
    }

    @Override
    public void onResume() {
        super.onResume();
        ViewGroup.LayoutParams params = getDialog().getWindow().getAttributes();
        DisplayMetrics displayMetrics = new DisplayMetrics();
        getActivity().getWindowManager().getDefaultDisplay().getMetrics(displayMetrics);
        int width = displayMetrics.widthPixels;
        params.height = ViewGroup.LayoutParams.MATCH_PARENT;
        params.width = Double.valueOf(width * 0.9).intValue();
        getDialog().getWindow().setAttributes((android.view.WindowManager.LayoutParams) params);
    }

    @NonNull
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        // remove title from dialog
        Dialog dialog = new Dialog(getActivity(), R.style.Dialog);
        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
        dialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));

        setCancelable(false);
        return dialog;
    }

    public ViewGroup getContainer() {
        return binding.container;
    }
}
