package com.ibm.gbs.va.grit.fragment.dialog;

import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.FragmentManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.ibm.gbs.va.grit.R;
import com.ibm.gbs.va.grit.activity.AuthenticationActivity;
import com.ibm.gbs.va.grit.fragment.login.IAuthenticationFragment;

public class ResetPasswordDialogFragment extends ChangePasswordDialogFragment
        implements IAuthenticationFragment {

    public static void showInstance(FragmentManager fragmentManager) {
        ResetPasswordDialogFragment dialog = new ResetPasswordDialogFragment();
        dialog.show(fragmentManager, CHANGE_PASSWORD_DIALOG_TAG);
    }

    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        super.onCreateView(inflater, container, savedInstanceState);
        binding.oldPasswordLayout.setHint(getString(R.string.temporary_password));
        return binding.getRoot();
    }

    @Override
    public AuthenticationActivity getAuthenticationActivity() {
        return (AuthenticationActivity)getActivity();
    }

    @Override
    protected void onSubmit() {
        updatingPassword = model.resetTempPassword();
        updatingPassword.observe(this, passwordUpdated -> {
            if (passwordUpdated != null && passwordUpdated) {
                dismiss();
                getAuthenticationActivity().enterApp();
            }
            updatingPassword.removeObservers(this);
        });
    }
}
