package com.ibm.gbs.va.grit.fragment.login;

import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ScrollView;

import com.ibm.gbs.va.grit.R;
import com.ibm.gbs.va.grit.activity.AuthenticationActivity;
import com.ibm.gbs.va.grit.databinding.FragmentPrivacyBinding;
import com.ibm.gbs.va.grit.fragment.AnalyticsFragment;
import com.ibm.gbs.va.grit.repository.UserRepository;

import javax.inject.Inject;

public class PrivacyFragment extends AnalyticsFragment implements IAuthenticationFragment {
    private FragmentPrivacyBinding binding;

    @Inject
    UserRepository userRepo;

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        TAG = "PrivacyFragment";
        assert getActivity() != null;
        binding = FragmentPrivacyBinding.inflate(inflater, container, false);
        binding.setLifecycleOwner(this);
        binding.getStartedBtn.setOnClickListener(v -> {
            userRepo.setUserAcceptedPolicy(true);
            getAuthenticationActivity().goToSignUp();
        });
        binding.fullPrivacyLinkBtn.setOnClickListener(v -> showHideFullText());
        binding.loginLinkBtn.setOnClickListener(v -> getAuthenticationActivity().goToLogin(null));
        binding.fullPrivacyTextWebView.loadDataWithBaseURL(null, getString(R.string.privacy_full), "text/html", "utf-8", null);
        binding.goToTopImageView.setOnClickListener(v -> binding.privacyScrollView.fullScroll(ScrollView.FOCUS_UP));
        binding.goToBottomImageView.setOnClickListener(v -> binding.privacyScrollView.fullScroll(ScrollView.FOCUS_DOWN));
        return binding.getRoot();
    }

    private void showHideFullText() {
        if (binding.fullPrivacyTextWebView.getVisibility() == View.VISIBLE) {
            binding.fullPrivacyTextWebView.setVisibility(View.GONE);
            binding.goToTopImageView.setVisibility(View.GONE);
            binding.goToBottomImageView.setVisibility(View.GONE);
        } else {
            binding.fullPrivacyTextWebView.setVisibility(View.VISIBLE);
            binding.goToTopImageView.setVisibility(View.VISIBLE);
            binding.goToBottomImageView.setVisibility(View.VISIBLE);
        }
    }

    @Override
    public AuthenticationActivity getAuthenticationActivity() {
        return (AuthenticationActivity) getActivity();
    }
}
