package com.ibm.gbs.va.grit.model.dialog;

import android.graphics.drawable.Drawable;
import android.support.annotation.DrawableRes;

import java.util.List;

public class BadgeDialogModel extends BaseDialogModel {
    public static BadgeDialogBuilder builder() {
        return new BadgeDialogBuilder();
    }

    ///////////////////////////////////
    // Fields
    private Drawable dynamicBackground;
    private int background;
    private final Drawable badge;
    private final String title;

    public BadgeDialogModel(int bannerColor, ButtonConfig topButton, ButtonConfig bottomButton, List<TextSection> sections, boolean scrollable, Drawable background, Drawable badge, String title) {
        super(bannerColor, topButton, bottomButton, sections, scrollable);
        this.dynamicBackground = background;
        this.badge = badge;
        this.title = title;
    }

    public BadgeDialogModel(int bannerColor, ButtonConfig topButton, ButtonConfig bottomButton, List<TextSection> sections, boolean scrollable, @DrawableRes int background, Drawable badge, String title) {
        super(bannerColor, topButton, bottomButton, sections, scrollable);
        this.background = background;
        this.badge = badge;
        this.title = title;
    }

    ///////////////////////////////////
    // Getters
    public Drawable getDynamicBackground() {
        return dynamicBackground;
    }

    public int getBackground() {
        return background;
    }

    public Drawable getBadge() {
        return badge;
    }

    public String getTitle() {
        return title;
    }

    ///////////////////////////////////
    // Builder
    public static class BadgeDialogBuilder extends Builder<BadgeDialogBuilder> {

        private int background;
        private Drawable badge;
        private String title;

        BadgeDialogBuilder() {
            super(BadgeDialogBuilder.class);
        }

        public BadgeDialogBuilder withBackground(int bannerImageResId) {
            this.background = bannerImageResId;
            return this;
        }

        public BadgeDialogBuilder withBadge(Drawable dynamicBannerIcon) {
            this.badge = dynamicBannerIcon;
            return this;
        }

        public BadgeDialogBuilder withTitle(String dynamicTitle) {
            this.title = dynamicTitle;
            return this;
        }

        public BadgeDialogModel build() {
            return new BadgeDialogModel(
                    this.bannerColor,
                    this.topButton,
                    this.bottomButton,
                    this.sections,
                    this.scrollable,
                    this.background,
                    this.badge,
                    this.title);
        }
    }
}

