package com.ibm.gbs.va.grit.model.dialog;

import android.support.annotation.ColorRes;
import android.support.annotation.DimenRes;
import android.support.annotation.StringRes;
import android.view.View;

public class ButtonConfig {
    public final @StringRes
    int text;
    public final @ColorRes
    int buttonColor;
    public final @ColorRes
    int textColor;
    public final @ColorRes
    Integer strokeColor;
    public final @DimenRes
    Integer strokeWidth;

    private View.OnClickListener onClickListener = (v) -> {
    };

    public View.OnClickListener getOnClickListener() {
        return onClickListener;
    }

    private ButtonConfig(@StringRes int text, @ColorRes int textColor, @ColorRes int buttonColor, @ColorRes Integer strokeColor, @DimenRes Integer strokeWidth) {
        this.text = text;
        this.buttonColor = buttonColor;
        this.textColor = textColor;
        this.strokeColor = strokeColor;
        this.strokeWidth = strokeWidth;
    }

    public ButtonConfig(@StringRes int text, @ColorRes int textColor, @ColorRes int buttonColor) {
        this(text, textColor, buttonColor, null, null);
    }

    public ButtonConfig copyWithText(@StringRes int text) {
        return new ButtonConfig(text, this.textColor, this.buttonColor, this.strokeColor, this.strokeWidth);
    }

    public ButtonConfig withOnClick(View.OnClickListener onClickListener) {
        this.onClickListener = onClickListener;
        return this;
    }
}
