package com.ibm.gbs.va.grit.model.dialog;

import android.support.annotation.StringRes;
import android.support.annotation.StyleRes;

import com.ibm.gbs.va.grit.R;

public class TextSection {
    @StringRes
    public final Integer simpleText;
    @StringRes
    public final Integer bulletedText;
    public final String dynamicText;
    @StyleRes
    public final int textAppearance;
    public final boolean centered;

    public static TextSection ofText(@StringRes int simpleText) {
        return TextSection.ofText(simpleText, R.style.Body, true);
    }

    public static TextSection ofDynamicText(String dynamicText) {
        return TextSection.ofDynamicText(dynamicText, R.style.Body, false);
    }

    public static TextSection ofBullet(@StringRes int bulletedText, @StyleRes int textAppearance) {
        return new TextSection(null, bulletedText, null, textAppearance, false);
    }

    public static TextSection ofBullet(@StringRes int bulletedText, @StyleRes int textAppearance, boolean centered) {
        return new TextSection(null, bulletedText, null, textAppearance, centered);
    }

    public static TextSection ofCenteredText(@StringRes int simpleText, @StyleRes int textAppearance) {
        return new TextSection(simpleText, null, null, textAppearance, true);
    }

    public static TextSection ofText(@StringRes int simpleText, @StyleRes int textAppearance, boolean centered) {
        return new TextSection(simpleText, null, null, textAppearance, centered);
    }

    public static TextSection ofDynamicText(String dynamicText, @StyleRes int textAppearance, boolean centered) {
        return new TextSection(null, null, dynamicText, textAppearance, centered);
    }

    private TextSection(@StringRes Integer simpleText, @StringRes Integer bulletedText, String dynamicText, @StyleRes int textAppearance, boolean centered) {
        this.simpleText = simpleText;
        this.bulletedText = bulletedText;
        this.dynamicText = dynamicText;
        this.textAppearance = textAppearance;
        this.centered = centered;
    }
}
