package com.ibm.gbs.va.grit.model.request;

import android.support.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;

import java.util.HashMap;
import java.util.Map;

public class AddHandleRequest {
    @SerializedName("socialMediaType")
    private SocialMediaType socialMediaType;
    @SerializedName("handle")
    private String handle;

    public AddHandleRequest(SocialMediaType socialMediaType, String handle) {
        this.socialMediaType = socialMediaType;
        this.handle = handle;
    }

    public SocialMediaType getSocialMediaType() {
        return socialMediaType;
    }

    public void setSocialMediaType(SocialMediaType socialMediaType) {
        this.socialMediaType = socialMediaType;
    }

    public String getHandle() {
        return handle;
    }

    public void setHandle(String handle) {
        this.handle = handle;
    }

    @NonNull
    @Override
    public String toString() {
        return new Gson().toJson(this);
    }

    public enum SocialMediaType {

        @SerializedName("TWITTER")
        TWITTER("TWITTER"),
        @SerializedName("FACEBOOK")
        FACEBOOK("FACEBOOK");
        private final String value;

        private final static Map<String, AddHandleRequest.SocialMediaType> CONSTANTS = new HashMap<>();

        static {
            for (AddHandleRequest.SocialMediaType c : values()) {
                CONSTANTS.put(c.value, c);
            }
        }

        SocialMediaType(String value) {
            this.value = value;
        }

        @NonNull
        @Override
        public String toString() {
            return value();
        }

        String value() {
            return this.value;
        }

        @SuppressWarnings("unused")
        public static AddHandleRequest.SocialMediaType fromValue(String value) {
            AddHandleRequest.SocialMediaType constant = CONSTANTS.get(value);
            if (constant == null) {
                throw new IllegalArgumentException(value);
            } else {
                return constant;
            }
        }

    }
}
