package com.ibm.gbs.va.grit.model.request;

import android.support.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;
import com.ibm.gbs.va.grit.model.type.SavedJob;

public class AddSavedJobRequest {
    @SerializedName("jobId")
    private String jobId;

    @SerializedName("jobTitle")
    private String jobTitle;

    @SerializedName("employer")
    private String employer;

    @SerializedName("location")
    private String location;

    @SerializedName("minSalary")
    private String minSalary;

    @SerializedName("maxSalary")
    private String maxSalary;

    @SerializedName("applicationURL")
    private String applicationURL;

    public AddSavedJobRequest(SavedJob job) {
        this.jobId = job.getJobId();
        this.jobTitle = job.getJobTitle();
        this.employer = job.getEmployer();
        this.location = job.getLocation();
        this.minSalary = job.getMinSalary();
        this.maxSalary = job.getMaxSalary();
        this.applicationURL = job.getApplicationURL();
    }

    public String getJobId() {
        return jobId;
    }

    public String getJobTitle() {
        return jobTitle;
    }

    public String getEmployer() {
        return employer;
    }

    public String getLocation() {
        return location;
    }

    public String getMinSalary() {
        return minSalary;
    }

    public String getMaxSalary() {
        return maxSalary;
    }

    public String getApplicationURL() {
        return applicationURL;
    }

    @NonNull
    @Override
    public String toString() {
        return new Gson().toJson(this);
    }
}
