package com.ibm.gbs.va.grit.model.request;

import android.support.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;
import com.ibm.gbs.va.grit.model.notifications.Notification;
import com.ibm.gbs.va.grit.model.survey.QuestionSet;

public class GetQuestionSetRequest {

    @SerializedName("newSession")
    private boolean newSession;

    @SerializedName("questionSetType")
    private QuestionSet.Type questionSetType;

    /**
     * Any notification metadata that will be echoed back as-is. Should only be supplied if
     * newSession is true and questionSetType is BASELINE.
     *
     * @since 12 Nov 2018
     */
    @SerializedName("metadata")
    private String metadata;

    public GetQuestionSetRequest(boolean newSession, Notification notification) {
        this.newSession = newSession;
        this.questionSetType = QuestionSet.Type.fromValue(notification);
        this.metadata = (newSession && (questionSetType == QuestionSet.Type.BASELINE)) ?
                notification.getMetadata() :
                "";
    }

    public boolean isNewSession() {
        return newSession;
    }

    public void setNewSession(boolean newSession) {
        this.newSession = newSession;
    }

    public QuestionSet.Type getQuestionSetType() {
        return questionSetType;
    }

    public void setQuestionSetType(QuestionSet.Type questionSetType) {
        this.questionSetType = questionSetType;
    }

    public String getMetadata() {
        return metadata;
    }

    public void setMetadata(String metadata) {
        this.metadata = metadata;
    }

    @NonNull
    @Override
    public String toString() {
        return new Gson().toJson(this);
    }
}
