package com.ibm.gbs.va.grit.model.request;

import android.support.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;
import com.ibm.gbs.va.grit.model.survey.Answer;
import com.ibm.gbs.va.grit.model.survey.QuestionSet;

import java.util.List;

public class SubmitSurveyRequest {
    @SerializedName("questionSetId")
    private String questionSetId;

    @SerializedName("questionSetType")
    private QuestionSet.Type questionSetType;

    @SerializedName("abortSurveySession")
    private boolean abortSurveySession;

    @SerializedName("version")
    private int version;

    @SerializedName("answers")
    private List<Answer> answers;

    public SubmitSurveyRequest(QuestionSet qSet, boolean abortSurveySession, List<Answer> answersList) {
        this.questionSetId = qSet.getQuestionSetId();
        this.questionSetType = qSet.getQuestionSetType();
        this.abortSurveySession = abortSurveySession;
        this.version = qSet.getVersion();
        this.answers = answersList;
    }

    public String getQuestionSetId() {
        return questionSetId;
    }

    public void setQuestionSetId(String questionSetId) {
        this.questionSetId = questionSetId;
    }

    public QuestionSet.Type getQuestionSetType() {
        return questionSetType;
    }

    public void setQuestionSetType(QuestionSet.Type questionSetType) {
        this.questionSetType = questionSetType;
    }

    public boolean isAbortSurveySession() {
        return abortSurveySession;
    }

    public void setAbortSurveySession(boolean abortSurveySession) {
        this.abortSurveySession = abortSurveySession;
    }

    public int getVersion() {
        return version;
    }

    public void setVersion(int version) {
        this.version = version;
    }

    public List<Answer> getAnswers() {
        return answers;
    }

    public void setAnswers(List<Answer> answers) {
        this.answers = answers;
    }

    @NonNull
    @Override
    public String toString() {
        return new Gson().toJson(this);
    }
}
