package com.ibm.gbs.va.grit.model.request;

import android.support.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;
import com.ibm.gbs.va.grit.model.type.EmploymentInfo;

import java.util.List;

public class UploadResumeInfoRequest {

    @SerializedName("desiredLocation")
    private String desiredLocation;

    @SerializedName("militaryBranch")
    private String militaryBranch;

    @SerializedName("mos")
    private String mos;

    @SerializedName("rank")
    private String rank;

    @SerializedName("targetIndustry")
    private String targetIndustry;

    @SerializedName("minimumSalary")
    private String minimumSalary;

    @SerializedName("jobTypes")
    private List<EmploymentInfo.JobType> jobTypes;

    public UploadResumeInfoRequest(@NonNull EmploymentInfo info) {
        desiredLocation = info.getDesiredLocation();
        militaryBranch = info.getMilitaryBranch() == null ? "" : info.getMilitaryBranch().value();
        mos = info.getMos();
        rank = info.getRank() == null ? "" : info.getRank().value();
        targetIndustry = info.getTargetIndustry();
        minimumSalary = info.getMinimumSalary();
        jobTypes = info.getJobTypes();
    }

    public String getDesiredLocation() {
        return desiredLocation;
    }

    public void setDesiredLocation(String desiredLocation) {
        this.desiredLocation = desiredLocation;
    }

    public String getMilitaryBranch() {
        return militaryBranch;
    }

    public void setMilitaryBranch(String militaryBranch) {
        this.militaryBranch = militaryBranch;
    }

    public String getMos() {
        return mos;
    }

    public void setMos(String mos) {
        this.mos = mos;
    }

    public String getRank() {
        return rank;
    }

    public void setRank(String rank) {
        this.rank = rank;
    }

    public String getTargetIndustry() {
        return targetIndustry;
    }

    public void setTargetIndustry(String targetIndustry) {
        this.targetIndustry = targetIndustry;
    }

    public String getMinimumSalary() {
        return minimumSalary;
    }

    public void setMinimumSalary(String minimumSalary) {
        this.minimumSalary = minimumSalary;
    }

    public List<EmploymentInfo.JobType> getJobTypes() {
        return jobTypes;
    }

    public void setJobTypes(List<EmploymentInfo.JobType> jobTypes) {
        this.jobTypes = jobTypes;
    }

    @NonNull
    @Override
    public String toString() {
        return new Gson().toJson(this);
    }
}
