package com.ibm.gbs.va.grit.model.request;

import android.support.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;

import java.util.HashMap;
import java.util.Map;

public class UploadResumeRequest {
    @SerializedName("uploadType")
    private UploadResumeRequest.UploadType uploadType;

    @SerializedName("filename")
    private String filename;

    @SerializedName("page")
    private Integer page;

    @SerializedName("data")
    private String data;

    public UploadResumeRequest(UploadResumeRequest.UploadType uploadType, String filename, Integer page, String data) {
        this.uploadType = uploadType;
        this.filename = filename;
        this.page = page;
        this.data = data;
    }

    public UploadResumeRequest.UploadType getUploadType() {
        return uploadType;
    }

    public void setUploadType(UploadResumeRequest.UploadType uploadType) {
        this.uploadType = uploadType;
    }

    public String getFilename() {
        return filename;
    }

    public void setFilename(String filename) {
        this.filename = filename;
    }

    public int getPage() {
        return page;
    }

    public void setPage(int page) {
        this.page = page;
    }

    public String getData() {
        return data;
    }

    public void setData(String data) {
        this.data = data;
    }

    @NonNull
    @Override
    public String toString() {
        return new Gson().toJson(this);
    }

    public enum UploadType {
        @SerializedName("PHOTO")
        PHOTO("PHOTO"),
        @SerializedName("WORD")
        WORD("WORD"),
        @SerializedName("PDF")
        PDF("PDF");

        private final String value;

        private final static Map<String, UploadResumeRequest.UploadType> CONSTANTS = new HashMap<>();

        static {
            for (UploadResumeRequest.UploadType c : values()) {
                CONSTANTS.put(c.value, c);
            }
        }

        UploadType(String value) {
            this.value = value;
        }

        @NonNull
        @Override
        public String toString() {
            return value();
        }

        public String value() {
            return this.value;
        }

        @SuppressWarnings("unused")
        public static UploadResumeRequest.UploadType fromValue(String value) {
            UploadResumeRequest.UploadType constant = CONSTANTS.get(value);
            if (constant == null) {
                throw new IllegalArgumentException(value);
            } else {
                return constant;
            }
        }

    }
}
