package com.ibm.gbs.va.grit.model.response;

import android.support.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;
import com.ibm.gbs.va.grit.model.type.Status;

import java.util.List;

public class BaseResponse<T> {

    @SerializedName("status")
    private Status status;

    @SerializedName("payload")
    private T payload;

    @SerializedName("badgeAward")
    private List<String> badgeAward;

    public Status getStatus() {
        return status;
    }

    public void setStatus(Status status) {
        this.status = status;
    }

    public T getPayload() {
        return payload;
    }

    public void setPayload(T payload) {
        this.payload = payload;
    }

    public List<String> getBadgeAward() {
        return badgeAward;
    }

    public void setBadgeAward(List<String> badgeAward) {
        this.badgeAward = badgeAward;
    }

    public BaseResponse(Status.StatusType status, String errorMessage) {
        this.status = new Status(status.value(), errorMessage);
    }

    @NonNull
    @Override
    public String toString() {
        return new Gson().toJson(this);
    }
}