package com.ibm.gbs.va.grit.model.response;

import android.support.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;
import com.ibm.gbs.va.grit.model.request.AddHandleRequest;
import com.ibm.gbs.va.grit.model.type.Handle;

import java.util.List;

public class GetHandlesResponse {
    @SerializedName("handles")
    private List<Handle> handles;

    public List<Handle> getHandles() {
        return handles;
    }

    public void setHandles(List<Handle> handles) {
        this.handles = handles;
    }

    public Handle getHandleOfType(AddHandleRequest.SocialMediaType type) {
        for (Handle handle : this.handles) {
            if (handle.getSocialMediaType() == type) {
                return handle;
            }
        }
        return new Handle(type);
    }

    @NonNull
    @Override
    public String toString() {
        return new Gson().toJson(this);
    }
}
