package com.ibm.gbs.va.grit.model.response;

import android.support.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;

import java.util.List;

public class UploadResumeInfoResponse {
    @SerializedName("validationErrors")
    private List<String> valiidationErrors;

    public enum ResumeValidationError {INVALID_MOS, INVALID_LOCATION, VALID}

    public List<String> getValiidationErrors() {
        return valiidationErrors;
    }

    public void setValiidationErrors(List<String> valiidationErrors) {
        this.valiidationErrors = valiidationErrors;
    }

    public boolean hasValidationErrors() {
        return valiidationErrors != null && valiidationErrors.size() > 0;
    }

    public boolean hasValidationErrorOfType(ResumeValidationError resumeValidationError) {
        if (hasValidationErrors()) {
            for (String error : valiidationErrors) {
                if (error.equals(resumeValidationError.name())) {
                    return true;
                }
            }
        }
        return false;
    }

    @NonNull
    @Override
    public String toString() {
        return new Gson().toJson(this);
    }
}
