package com.ibm.gbs.va.grit.model.survey;

import android.arch.persistence.room.ColumnInfo;
import android.arch.persistence.room.Entity;
import android.support.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;

import java.util.List;

@Entity
public class QuestionContent {
    @SerializedName("options")
    private List<SelectOption> options;

    @SerializedName("noneOfTheAbove")
    @ColumnInfo(name = "none_of_the_above")
    private boolean noneOfTheAbove;

    @SerializedName("other")
    @ColumnInfo(name = "other_select_option")
    private OtherSelectOption otherSelectOption;

    @SerializedName("range")
    private NumericRange range;

    public List<SelectOption> getOptions() {
        return options;
    }

    public void setOptions(List<SelectOption> options) {
        this.options = options;
    }

    public boolean getNoneOfTheAbove() {
        return noneOfTheAbove;
    }

    public void setNoneOfTheAbove(boolean noneOfTheAbove) {
        this.noneOfTheAbove = noneOfTheAbove;
    }

    public OtherSelectOption getOtherSelectOption() {
        return otherSelectOption;
    }

    public void setOtherSelectOption(OtherSelectOption otherSelectOption) {
        this.otherSelectOption = otherSelectOption;
    }

    public NumericRange getRange() {
        return range;
    }

    public void setRange(NumericRange range) {
        this.range = range;
    }

    public Integer getIndexForAnswerId(String id) {
        for (int i = 0; i < options.size(); i++) {
            SelectOption option = options.get(i);
            if (option.getAnswerId().equals(id)) return i;
        }
        return null;
    }

    @NonNull
    @Override
    public String toString() {
        return new Gson().toJson(this);
    }
}
