package com.ibm.gbs.va.grit.model.type;

import android.databinding.BaseObservable;
import android.databinding.Bindable;
import android.support.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;
import com.ibm.gbs.va.grit.BR;
import com.ibm.gbs.va.grit.model.request.AddHandleRequest;

public class Handle extends BaseObservable {
    @SerializedName("socialMediaType")
    private AddHandleRequest.SocialMediaType socialMediaType;
    @SerializedName("handle")
    private String handle;
    @SerializedName("id")
    private String id;

    public Handle(AddHandleRequest.SocialMediaType socialMediaType) {
        this.socialMediaType = socialMediaType;
        this.handle = "";
        this.id = "";
    }

    public Handle(AddHandleRequest.SocialMediaType socialMediaType, String handle, String id) {
        this.socialMediaType = socialMediaType;
        this.handle = handle;
        this.id = id;
    }

    public AddHandleRequest.SocialMediaType getSocialMediaType() {
        return socialMediaType;
    }

    public void setSocialMediaType(AddHandleRequest.SocialMediaType socialMediaType) {
        this.socialMediaType = socialMediaType;
    }

    @Bindable
    public String getHandle() {
        return handle;
    }

    public void setHandle(String handle) {
        this.handle = handle;
        notifyPropertyChanged(BR.handle);
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @NonNull
    @Override
    public String toString() {
        return new Gson().toJson(this);
    }

    public Handle duplicate() {
        return new Handle(socialMediaType, handle, id);
    }
}
