package com.ibm.gbs.va.grit.model.type;

import android.support.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;

@SuppressWarnings("WeakerAccess")
public class MultiLangText {

    @SerializedName("en")
    private String en;

    @SerializedName("es")
    private String es;

    public String getEn() {
        return en;
    }

    public void setEn(String en) {
        this.en = en;
    }

    public String getEs() {
        return es;
    }

    public void setEs(String es) {
        this.es = es;
    }

    // Use only if you want the same text displayed across all localities,
    // or if the string being passed has already been localized by the android resource manager (I.E. ResID)
    public void setAll(String localized) {
        en = localized;
        es = localized;
    }


    @SuppressWarnings("unused")
    public String get(MultiLangText.Language language) {
        switch (language) {
            case EN:
                return this.getEn();
            case ES:
                return this.getEs();
        }
        return this.getEn();
    }

    @NonNull
    @Override
    public String toString() {
        return new Gson().toJson(this);
    }

    @SuppressWarnings("unused")
    public enum Language {
        EN("EN"), ES("ES");
        private String value;

        Language(String value) {
            this.value = value;
        }
    }
}
