package com.ibm.gbs.va.grit.model.type;

import android.support.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;

import java.util.List;

import androidx.annotation.Nullable;

public class Role {
    @SerializedName("title")
    private String title;

    @SerializedName("jobDescription")
    private String jobDescription;

    @SerializedName("industry")
    private String industry;

    @Nullable
    @SerializedName("meanExperience")
    private Double meanExperience;

    @SerializedName("demandLevel")
    private String demandLevel;

    @Nullable
    @SerializedName("employmentGrowth")
    private Double employmentGrowth;

    @SerializedName("skills")
    private List<SkillDetail> skills;

    public String getTitle() {
        return title;
    }

    public String getJobDescription() {
        return jobDescription;
    }

    public String getIndustry() {
        return industry;
    }

    @Nullable
    public Double getMeanExperience() {
        return meanExperience;
    }

    public String getDemandLevel() {
        return demandLevel.toUpperCase();
    }

    @Nullable
    public Double getEmploymentGrowth() {
        return employmentGrowth;
    }

    public List<SkillDetail> getSkills() {
        return skills;
    }

    @NonNull
    @Override
    public String toString() {
        return new Gson().toJson(this);
    }
}
