package com.ibm.gbs.va.grit.model.type;

import android.support.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;

public class Status {
    @SerializedName("statusType")
    private String statusType;
    @SerializedName("errorMessage")
    private String errorMessage;

    public Status(String statusType, String errorMessage) {
        this.statusType = statusType;
        this.errorMessage = errorMessage;
    }

    public String getStatusType() {
        return statusType;
    }

    public String getErrorMessage() {
        return errorMessage;
    }

    public StatusType getStatusTypeEnum() {
        try {
            return StatusType.valueOf(statusType);
        } catch (IllegalArgumentException iae) {
            return null;
        }
    }

    @NonNull
    @Override
    public String toString() {
        return new Gson().toJson(this);
    }

    public enum StatusType {

        @SerializedName("SUCCESS")
        SUCCESS("SUCCESS"),
        @SerializedName("INVALID_REQUEST")
        INVALID_REQUEST("INVALID_REQUEST"),
        @SuppressWarnings("unused")
        @SerializedName("INVALID_TOKEN")
        INVALID_TOKEN("INVALID_TOKEN"),
        @SerializedName("UNEXPECTED_EXCEPTION")
        UNEXPECTED_EXCEPTION("UNEXPECTED_EXCEPTION"),
        @SerializedName("LOGIN_FAILED")
        LOGIN_FAILED("LOGIN_FAILED"),
        @SerializedName("NO_QUESTIONS_AVAILABLE")
        NO_QUESTIONS_AVAILABLE("NO_QUESTIONS_AVAILABLE"),
        @SerializedName("EMAIL_IN_USE")
        EMAIL_IN_USE("EMAIL_IN_USE"),
        @SerializedName("OLD_PASSWORD_MISMATCH")
        OLD_PASSWORD_MISMATCH("OLD_PASSWORD_MISMATCH"),
        @SerializedName("OFFLINE")
        OFFLINE("OFFLINE"),
        @SerializedName("SQUAD_MATES_MAX_REACHED")
        SQUAD_MATES_MAX_REACHED("SQUAD_MATES_MAX_REACHED"),
        @SerializedName("SQUAD_MATE_ALREADY_EXISTS")
        SQUAD_MATE_ALREADY_EXISTS("SQUAD_MATE_ALREADY_EXISTS"),
        @SerializedName("HANDLE_NOT_VALID")
        HANDLE_NOT_VALID("HANDLE_NOT_VALID"),
        @SerializedName("NOT_UNIQUE")
        NOT_UNIQUE("NOT_UNIQUE"),
        @SerializedName("TEMP_PASSWORD_MISMATCH")
        TEMP_PASSWORD_MISMATCH("TEMP_PASSWORD_MISMATCH"),
        @SerializedName("NO_WEM_PROFILE")
        NO_WEM_PROFILE("NO_WEM_PROFILE"),
        @SerializedName("EMAIL_NOT_FOUND")
        EMAIL_NOT_FOUND("EMAIL_NOT_FOUND");

        private final String value;

        StatusType(String value) {
            this.value = value;
        }

        @NonNull
        @Override
        public String toString() {
            return value();
        }

        public String value() {
            return this.value;
        }
    }

}