package com.ibm.gbs.va.grit.model.type;

import android.support.annotation.DrawableRes;
import android.support.annotation.NonNull;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;
import com.ibm.gbs.va.grit.R;

public class WalkthroughStep {

    @DrawableRes
    public static final int WALKTHROUGH_BACKGROUND = R.drawable.walk_background;

    @SerializedName("walkthroughTitle")
    private MultiLangText walkthroughTitle;

    @SerializedName("walkthroughBody")
    private MultiLangText walkthroughBody;

    @SerializedName("walkthroughPicture")
    @DrawableRes
    private int walkthroughPicture = R.drawable.ic_logomark;

    public WalkthroughStep(MultiLangText walkthroughTitle, MultiLangText walkthroughBody, @DrawableRes int walkthroughPicture) {
        this.walkthroughTitle = walkthroughTitle;
        this.walkthroughBody = walkthroughBody;
        this.walkthroughPicture = walkthroughPicture;
    }

    public WalkthroughStep(MultiLangText walkthroughTitle, MultiLangText walkthroughBody) {
        this.walkthroughTitle = walkthroughTitle;
        this.walkthroughBody = walkthroughBody;
    }

    public MultiLangText getWalkthroughTitle() {
        return walkthroughTitle;
    }

    public String getDefaultWalkthroughTitle() {
        return walkthroughTitle.getEn();
    }

    public void setWalkthroughTitle(MultiLangText walkthroughTitle) {
        this.walkthroughTitle = walkthroughTitle;
    }

    public MultiLangText getWalkthroughBody() {
        return walkthroughBody;
    }

    public String getDefaultWalkthroughBody() {
        return walkthroughBody.getEn();
    }

    public void setWalkthroughBody(MultiLangText walkthroughBody) {
        this.walkthroughBody = walkthroughBody;
    }

    public int getWalkthroughPicture() {
        return walkthroughPicture;
    }

    public void setWalkthroughPicture(int walkthroughPicture) {
        this.walkthroughPicture = walkthroughPicture;
    }

    @NonNull
    @Override
    public String toString() {
        return new Gson().toJson(this);
    }
}
