package com.ibm.gbs.va.grit.repository;

import android.content.Context;

import com.ibm.gbs.va.grit.util.RemoteLog;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class LocationRepository {
    private static final String TAG = "LocationRepository";
    private final List<String> cities = new ArrayList<>();

    public LocationRepository(Context context) {
        try {
            InputStreamReader inputStream = new InputStreamReader(context.getAssets().open("US_cities.csv"));
            BufferedReader reader = new BufferedReader(inputStream);
            String line;
            while ((line = reader.readLine()) != null) {
                cities.add(line);
            }
        } catch (IOException e) {
            RemoteLog.e(TAG, "ERROR opening US_cities: " + e.getMessage(), e);
        }
    }

    public List<String> getCities() {
        return Collections.unmodifiableList(cities);
    }
}
