package com.ibm.gbs.va.grit.util;

import android.view.View;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class CompositeOnClickListener implements View.OnClickListener {
    private final List<View.OnClickListener> listeners;

    public CompositeOnClickListener(View.OnClickListener... listeners) {
        this.listeners = Arrays.asList(listeners);
    }

    public CompositeOnClickListener() {
        listeners = new ArrayList<>();
    }

    public void addOnClickListener(View.OnClickListener listener) {
        listeners.add(listener);
    }

    @Override
    public void onClick(View v) {
        for (View.OnClickListener listener : listeners) {
            if (listener != null) listener.onClick(v);
        }
    }
}
