package com.ibm.gbs.va.grit.util;

import android.support.v4.app.FragmentActivity;

import com.karumi.dexter.Dexter;
import com.karumi.dexter.listener.PermissionGrantedResponse;

import java.util.concurrent.Callable;

public class GritPermissionHelper {
    private final FragmentActivity activity;
    private final String permissionJustification;

    private final String TAG;

    public GritPermissionHelper(FragmentActivity activity, String permissionJustification) {
        this.activity = activity;
        this.permissionJustification = permissionJustification;
        this.TAG = this.getClass().getSimpleName();
    }

    private FragmentActivity getActivity() {
        return activity;
    }

    private String getPermissionJustification() {
        return permissionJustification;
    }

    public void checkPermissions(String permission, Callable<?> myFunc) {
        RemoteLog.d(TAG, "checking for permission: " + permission);
        Dexter.withActivity(this.getActivity())
                .withPermission(permission)
                .withListener(new GritPermissionListener(this.getActivity(), this.getPermissionJustification()) {
                    @Override
                    public void onPermissionGranted(PermissionGrantedResponse response) {
                        try {
                            myFunc.call();
                        } catch (Exception e) {
                            RemoteLog.e(TAG, "ERROR calling permissionGranted callback: " + e.getMessage(), e);
                        }
                    }
                })
                .check();
    }
}

