package com.ibm.gbs.va.grit.util;

import android.graphics.Bitmap;
import android.util.Base64;

import java.io.ByteArrayOutputStream;

public class ImageUtil {
    private static final int OCR_COMPRESSION_QUALITY = 50;

    public static String cleanForOcr(Bitmap orig, boolean clean) {
        if (clean) {
            Bitmap b = orig;
            b = scaleBitmap(b, null, 1200);
            return bitmapToBase64Str(b);
        } else {
            return bitmapToBase64Str(orig);
        }
    }

    private static Bitmap scaleBitmap(Bitmap orig, Integer width, Integer height) {
        // original measurements
        int origWidth = orig.getWidth();
        int origHeight = orig.getHeight();

        if (width != null && origWidth > width && height == null) {
            float scale = (float) width / origWidth;
            // picture is wider than we want it, we calculate its target height
            int destHeight = Math.round(origHeight * scale);
            return Bitmap.createScaledBitmap(orig, width, destHeight, false);
        } else if (height != null && origHeight > height && width == null) {
            float scale = (float) height / origHeight;
            // picture is taller than we want it, we calculate its target height
            int destWidth = Math.round(origWidth * scale);
            return Bitmap.createScaledBitmap(orig, destWidth, height, false);
        } else if (width != null && height != null) {
            return Bitmap.createScaledBitmap(orig, width, height, false);
        } else {
            return orig;
        }
    }

    private static String bitmapToBase64Str(Bitmap bitmap) {
        ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
        bitmap.compress(Bitmap.CompressFormat.PNG, ImageUtil.OCR_COMPRESSION_QUALITY, byteArrayOutputStream);
        byte[] byteArray = byteArrayOutputStream.toByteArray();
        return Base64.encodeToString(byteArray, Base64.DEFAULT);
    }

}
