package com.ibm.gbs.va.grit.util;

import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.util.Log;

import com.crashlytics.android.Crashlytics;

@SuppressWarnings("unused")
public class RemoteLog {

    /**
     * @param tag Used to identify the source of a log message. It usually identifies the class or
     *            activity where the log call occurs.
     * @param msg The message you would like logged.
     */
    public static void v(@NonNull String tag, @NonNull String msg) {
        Crashlytics.log(Log.VERBOSE, tag, msg);
    }

    /**
     * @param tag Used to identify the source of a log message. It usually identifies the class or
     *            activity where the log call occurs.
     * @param msg The message you would like logged.
     * @param tr  An exception to log.
     */
    public static void v(@NonNull String tag, @NonNull String msg, @Nullable Throwable tr) {
        RemoteLog.v(tag, msg);
        Crashlytics.logException(tr);
    }

    /**
     * @param tag Used to identify the source of a log message. It usually identifies the class or
     *            activity where the log call occurs.
     * @param msg The message you would like logged.
     */
    public static void d(@NonNull String tag, @NonNull String msg) {
        Crashlytics.log(Log.DEBUG, tag, msg);
    }

    /**
     * @param tag Used to identify the source of a log message. It usually identifies the class or
     *            activity where the log call occurs.
     * @param msg The message you would like logged.
     * @param tr  An exception to log.
     */
    public static void d(@NonNull String tag, @NonNull String msg, @Nullable Throwable tr) {
        RemoteLog.d(tag, msg);
        Crashlytics.logException(tr);
    }

    /**
     * @param tag Used to identify the source of a log message. It usually identifies the class or
     *            activity where the log call occurs.
     * @param msg The message you would like logged.
     */
    public static void i(@NonNull String tag, @NonNull String msg) {
        Crashlytics.log(Log.INFO, tag, msg);
    }

    /**
     * @param tag Used to identify the source of a log message. It usually identifies the class or
     *            activity where the log call occurs.
     * @param msg The message you would like logged.
     * @param tr  An exception to log.
     */
    public static void i(@NonNull String tag, @NonNull String msg, @Nullable Throwable tr) {
        RemoteLog.i(tag, msg);
        Crashlytics.logException(tr);
    }

    /**
     * @param tag Used to identify the source of a log message. It usually identifies the class or
     *            activity where the log call occurs.
     * @param msg The message you would like logged.
     */
    public static void w(@NonNull String tag, @NonNull String msg) {
        Crashlytics.log(Log.WARN, tag, msg);
    }

    /**
     * @param tag Used to identify the source of a log message. It usually identifies the class or
     *            activity where the log call occurs.
     * @param msg The message you would like logged.
     * @param tr  An exception to log.
     */
    public static void w(@NonNull String tag, @NonNull String msg, @Nullable Throwable tr) {
        RemoteLog.w(tag, msg);
        Crashlytics.logException(tr);
    }

    /**
     * @param tag Used to identify the source of a log message. It usually identifies the class or
     *            activity where the log call occurs.
     * @param msg The message you would like logged.
     */
    public static void e(@NonNull String tag, @NonNull String msg) {
        Crashlytics.log(Log.ERROR, tag, msg);
    }

    /**
     * @param tag Used to identify the source of a log message. It usually identifies the class or
     *            activity where the log call occurs.
     * @param msg The message you would like logged.
     * @param tr  An exception to log.
     */
    public static void e(@NonNull String tag, @NonNull String msg, @Nullable Throwable tr) {
        RemoteLog.e(tag, msg);
        Crashlytics.logException(tr);
    }

    /**
     * Adds current screen information to any generated crash log.
     *
     * @param screen the screen the app is currently displaying
     */
    public static void setCurrentScreen(String screen) {
        Crashlytics.setString("current_screen", screen);
    }
}
