package com.ibm.gbs.va.grit.util;

public class StringUtil {
    public static final String TAG = "StringUtil";

    public static String toTitleCase(String str) {
        if (str == null) return null;

        boolean space = true;
        StringBuilder builder = new StringBuilder(str);
        final int len = builder.length();

        for (int i = 0; i < len; ++i) {
            char c = builder.charAt(i);
            if (space) {
                if (!Character.isWhitespace(c) && c != '_') {
                    // Convert to title case and switch out of whitespace mode.
                    builder.setCharAt(i, Character.toTitleCase(c));
                    space = false;
                }
            } else if (Character.isWhitespace(c) || c == '_') {
                builder.setCharAt(i, ' ');
                space = true;
            } else {
                builder.setCharAt(i, Character.toLowerCase(c));
            }
        }

        return builder.toString();
    }

    public static String getRangeString(String min, String max) {
        String retString = "";
        if (min != null && !min.isEmpty()) {
            retString += min;
        }
        if (max != null && !max.isEmpty() && min != null && !min.isEmpty()) {
            retString += " - " + max;
        } else if (max != null && !max.isEmpty()) {
            retString += max;
        }
        return retString;
    }

    public static String capitalize(String value) {
        if (value == null || value.isEmpty()) {
            return value;
        } else if (value.length() == 1) {
            return value.substring(0, 1).toUpperCase();
        } else {
            return value.substring(0, 1).toUpperCase() + value.substring(1);
        }
    }

    public static String convertEmailCase(String email) {
        int barrier = email.indexOf("@");
        String domain = email.substring(barrier).toLowerCase();
        String emailPart = email.substring(0, barrier);
        String ret = emailPart + domain;
        RemoteLog.d(TAG, "email parts for conversion: emailPart-" + emailPart + "; domain-" + domain + "; ret-" + ret);
        return ret;
    }
}
