package com.ibm.gbs.va.grit.viewmodel;

import android.arch.lifecycle.LiveData;
import android.arch.lifecycle.ViewModel;
import android.databinding.ObservableField;

import com.ibm.gbs.va.grit.repository.UserRepository;

import javax.inject.Inject;

public class ChangePasswordViewModel extends ViewModel {

    public final ObservableField<String> oldPassword = new ObservableField<>();
    public final ObservableField<String> newPassword = new ObservableField<>();

    private final UserRepository userRepo;

    @Inject
    public ChangePasswordViewModel(UserRepository userRepo) {
        this.userRepo = userRepo;
    }

    public LiveData<Boolean> updatePassword() {
        return userRepo.updateUserPassword(oldPassword.get(), newPassword.get());
    }

    public LiveData<Boolean> resetTempPassword() {
        return userRepo.resetTempPassword(oldPassword.get(), newPassword.get());
    }

    public String getUserEmail() {
        return userRepo.getCurrentUserEmail();
    }
}
