package com.ibm.gbs.va.grit.viewmodel;

import android.arch.lifecycle.LiveData;
import android.arch.lifecycle.ViewModel;

import com.ibm.gbs.va.grit.model.chat.ChatMessage;
import com.ibm.gbs.va.grit.repository.ChatRepository;
import com.ibm.gbs.va.grit.repository.UserRepository;

import java.util.List;

import javax.inject.Inject;

public class ChatViewModel extends ViewModel {

    private final ChatRepository chatRepo;
    private final UserRepository userRepo;

    @Inject
    public ChatViewModel(ChatRepository chatRepo, UserRepository userRepo) {
        this.chatRepo = chatRepo;
        this.userRepo = userRepo;
    }

    public boolean isFirstTimeInfo() {
        return userRepo.getOnboardingDigitalAssistInfo();
    }

    public void setFirstTimeInfo(boolean firstTimeInfo) {
        userRepo.setOnboardingDigitalAssistInfo(firstTimeInfo);
    }

    public LiveData<List<ChatMessage>> getMessages() {
        return chatRepo.getMessages();
    }

    public void converse(ChatMessage message) {
        chatRepo.converse(message);
    }

}
