package com.ibm.gbs.va.grit.viewmodel;

import android.arch.lifecycle.LiveData;
import android.arch.lifecycle.ViewModel;
import android.databinding.ObservableField;

import com.ibm.gbs.va.grit.model.type.User;
import com.ibm.gbs.va.grit.repository.UserRepository;

import javax.inject.Inject;

public class ForgotPasswordViewModel extends ViewModel {

    public final ObservableField<String> email = new ObservableField<>();

    private final UserRepository userRepo;

    @Inject
    public ForgotPasswordViewModel(UserRepository userRepo) {
        this.userRepo = userRepo;
    }

    public LiveData<User> callForgotPassword() {
        return userRepo.callForgotPassword(email.get());
    }
}
