package com.ibm.gbs.va.grit.viewmodel;

import android.arch.lifecycle.MediatorLiveData;
import android.databinding.BaseObservable;
import android.databinding.Observable;

public class GritMutableLiveData<T extends BaseObservable> extends MediatorLiveData<T> {

    @Override
    public void setValue(T value) {
        super.setValue(value);

        //listen to property changes
        if (value != null) {
            value.addOnPropertyChangedCallback(callback);
        }
    }

    private final Observable.OnPropertyChangedCallback callback = new Observable.OnPropertyChangedCallback() {
        @Override
        public void onPropertyChanged(Observable sender, int propertyId) {

            //Trigger LiveData observer on change of any property in object
            setValue(getValue());

        }
    };
}
