package com.ibm.gbs.va.grit.viewmodel;

import android.arch.lifecycle.LiveData;
import android.arch.lifecycle.ViewModel;

import com.ibm.gbs.va.grit.model.type.SquadMember;
import com.ibm.gbs.va.grit.repository.SquadRepository;
import com.ibm.gbs.va.grit.util.UserPrefs;

import java.util.List;

import javax.inject.Inject;

public class SquadViewModel extends ViewModel {

    private final SquadRepository squadRepo;
    private final UserPrefs userPrefs;

    @Inject
    public SquadViewModel(SquadRepository squadRepo, UserPrefs userPrefs) {
        this.squadRepo = squadRepo;
        this.userPrefs = userPrefs;
    }

    public LiveData<List<SquadMember>> getSquad() {
        return squadRepo.getSquad();
    }

    public void addSquad(SquadMember member) {
        squadRepo.addSquad(member);
    }

    public boolean isFirstTimeInfo() {
        return userPrefs.getPrefSquadInfo();
    }

    public void setFirstTimeInfo(boolean firstTimeInfo) {
        userPrefs.setPrefSquadInfo(firstTimeInfo);
    }

    public void removeSquadMember(SquadMember member) {
        squadRepo.removeSquadMember(member);
    }
}
