

'use strict';

// Module dependencies
var express    = require('express'),
    restful = require('node-restful'),
    extend = require('util')._extend,
    config  = require('./config'),
    bluemix = require('./bluemix'),
    mongoose = restful.mongoose;
	mongoose.connect(config.services.mongodb, {dbName: "wemdb"}); 
	

module.exports = function (app) {
	
  mongoose.connect(config.services.mongodb, {dbName: "wemdb"}); 
  
  var gritJobs = app.resource = gritJobsModel;
  gritJobs.methods(['get', 'post', 'put', 'delete']);
  gritJobs.register(app, '/db/gritJobs');
  
  var gritCandidate = app.resource = gritCandidateModel;
  gritCandidate.methods(['get', 'post', 'put', 'delete']);
  gritCandidate.register(app, '/db/gritcandidates');

  var MSAlookup = app.resource = MSAlookupModel;
  MSAlookup.methods(['get', 'post', 'put', 'delete']);
  MSAlookup.register(app, '/db/MSAlookup');

  var WDSJoblookup = app.resource = WDSJoblookupModel;
  WDSJoblookup.methods(['get', 'post', 'put', 'delete']);
  WDSJoblookup.register(app, '/db/WDSJoblookup');
  
};

var jobSchema = mongoose.Schema({
     	
     	_id: {type:mongoose.Schema.Types.ObjectId},
		JobID: {type: String,unique:true},
		CleanJobTitle: "string",
		JobDomain: "string",
		CanonCity: "string",
		CanonCountry: "string",
		CanonState: "string",
		JobDate: "string",
		JobText: "string",
		JobURL: "string",
		PostingHTML: "string",
		Source: "string",
		JobReferenceID: "string",
		Email: "string",
		CanonEmployer: "string",
		Latitude: "string",
		Longitude: "string",
		CanonIntermediary: "string",
		Telephone: "string",
		CanonJobTitle: "string",
		CanonCounty: "string",
		DivisionCode: "string",
		MSA: "string",
		LMA: "string",
		InternshipFlag: "string",
		ConsolidatedONET: "string",
		CanonCertification: "string",
		CanonSkillClusters: "string",
		CanonSkills: "string",
		IsDuplicate: "string",
		IsDuplicateOf: "string",
		CanonMaximumDegree: "string",
		CanonMinimumDegree: "string",
		CanonOtherDegrees: "string",
		CanonPreferredDegrees: "string",
		CanonRequiredDegrees: "string",
		CIPCode: "string",
		StandardMajor: "string",
		MaxExperience: "string",
		MinExperience: "string",
		ConsolidatedInferredNAICS: "string",
		BGTOcc: "string",
		MaxAnnualSalary: "number",
		MaxHourlySalary: "number",
		MinAnnualSalary: "number",
		MinHourlySalary: "number",
		YearsOfExperience: "string",
		CanonJobHours: "string",
		CanonJobType: "string",
		CanonPostalCode: "string",
		CanonYearsOfExperienceCanonLevel: "string",
		CanonYearsOfExperienceLevel: "string",
		ConsolidatedTitle: "string",
		Language: "string",
		BGTSubOcc: "string",
		ConsolidatedDegreeLevels: "string",
		MaxDegreeLevel: "string",
		MinDegreeLevel: "string",
		wdsDocId: "string",
		UploadDate: "string"
	  
    });

var gritJobsModel = restful.model('gritJobs', jobSchema, 'gritJobs');
module.exports.gritJobsModel = gritJobsModel;

var gritCandidateSchema = mongoose.Schema({
	  _id: {type:mongoose.Schema.Types.ObjectId},
	  candidateName: "string",
	  resumeText : "string",
	  veteranID : {type: String,unique:true},
	  careerHistory: ["string"],
	  previousCompany : "string",
	  jobRole : "string",
	  moc: "string",
	  mocSkills : ["string"],
	  qualifications : "string",
	  location: ["string"],
	  //picURL : "string",
	  availableIn : "string",
	  experience: "number",
	  targetedIndustries : ["string"],
	  minSalary : "string",
      jobType : ["string"],
      militaryBranch : "string",
      militaryRank : "string",
      msa : "string"      
  });

var gritCandidateModel = restful.model('gritEmploymentProfile', gritCandidateSchema);
module.exports.gritCandidateModel = gritCandidateModel;


var WDSJoblookupSchema = mongoose.Schema({
    _id: {type:mongoose.Schema.Types.ObjectId},
    JobID: "string",
    document_id: "string"
});

var WDSJoblookupModel = restful.model('WDSJob_lookup', WDSJoblookupSchema);
module.exports.WDSJoblookupModel = WDSJoblookupModel;


var transactionSchema = mongoose.Schema({
	
	"transaction" : "object"
});

var transactionModel = restful.model('chatbot', transactionSchema);
module.exports.transactionModel = transactionModel;
