# Change Log

## Version 0.4.5
*2019-1-15*
- Add abortSurveySession checking for MOOD_FACES surveys to avoid flags session generating exception.

## Version 0.4.4
*2019-1-11*
- Use previous version of parsing BlueTAS sentimentScore values.

## Version 0.4.3
*2019-1-10*
- Update to OkHttp3 3.12.1
- Add timeouts to BlueTAS call.
- Update parsing of BlueTAS responses with sentimentScore.
- Add more general exception handling for BlueTAS API call.
- Adjust rules to schedule new MOOD_FACES and LIFE_CHANGES only during BL_CUSTOM_1.

## Version 0.4.2
*2019-1-9*
- Add many new test JSONs.
- Updates rules to always reschedule a new MOOD_FACES survey based on risk level if the user completes a MOOD_FACES survey.
- Add function NotificationsUtils.getLifeChangesNotification which generates a `Notification` for use in the notifications rules.

## Version 0.4.1
*2019-1-3*
- Remove kjar packaging and use default jar packaging.
- Adjust pom to use jupiter api and remove junit runner.
- Add RestTest for unit testing of REST API.
- Change to JUnit 5.4.0-M1

## Version 0.4.0
*2018-12-31*
- Change LIFE_CHANGES survey rescheduling to occur after 10 days have elapsed from the time the last LIFE_CHANGES survey went active.
- Fix issue where tweet sentiment slope was not being computed.
- Fix bug where notifications were searching "personId" instead of "vetId" field in MongoDB.

## Version 0.3.9
*2018-12-18*
- Update employment status recording for new answer mappings.
- Add additional test JSONs for aborting a survey.
- Change BlueTAS port from 9080 to 80.
- Add rule to handle updating months unemployed to zero when answering that the user is employed.

## Version 0.3.8
*2018-12-12*
- Update Mood Faces survey title to "Time for a check in"
- Add config.properties file to src/main/resources folder to project root to allow external configuration of PRODUCTION, MLAB, and MongoDB ConnectionString.

## Version 0.3.7
*2018-12-5*
- Fix DIGITAL_ASSISTANT notifications error due to empty `metadata` field the notification.
- Update URIs for calling to mid-tier and BlueTAS.
- Update purgeData API to remove SMS and Tweets.
- Add container_name to docker-compose.yml.

## Version 0.3.6
*2018-12-3*
- Fix runScoringRules to allow for missing socialMedia field in ScoreRequestData.
- Add function parseSocialMedia to ScoringUtils.
- Update README.
- Add rule to notify squad if high risk for the last 60 days.

## Version 0.3.5
*2018-11-30*
- Add Tweet class to store tweet data for users
- Add BlueTas class with methods to handle parsing of tweets.
- Add MongoCollection tweetCollection.
- Update runScoringRules to parse tweets and insert into MongoDB and scoring session.
- Add rule to compute 30-day sentiment slope and mean.
- Add rules to handle computing overall mood values with any combination of mood and sentiment values.
- Update basic needs and employability risk scoring and unit tests to add military housing option.
- Update employment question answers.
- Update health rules to add VA health services answer choice.
- Add anxiety to mental diagnosis options and update suicide scoring rules to accommodate anxiety.
- Add medical retirement for military discharge options.
- Update social religion answers with new values.
- Add new MLAB boolean switch to use production mLab MongoDB instance or local instance.
- Migrate to mLab hosted MongoDB instance.
- Comment out unit tests of social, suicide, and multi-ruleset testing.

## Version 0.3.4
*2018-11-29*
- Update README with more detailed rules documentation.
- Add Sms class used to store timestamped SMS records.
- Add smsCollection Mongo Collection to hold Sms objects.
- Add smsCollection global variable to notifications-rules.drl
- Insert Sms object into notifications rules session.
- Add notification rule to detect if squad was notified in the last 14 days.
- Add rule to notify squad if suicide risk high and mood slope exceeds threshold.
- Enforce 14 day cool down for squad notifications.
- Add rule to send IMMEDIATE_HELP notification if high risk any category other than suicide and mood slope exceeds threshold.

## Version 0.3.3
*2018-11-28*
- Update wording on BL_CUSTOM_2,BL_CUSTOM_3, and BL_CUSTOM_4 notification titles to "Initial Basic Needs", "Initial Health", and "Initial Social".
- Update immediate help notification description text.

## Version 0.3.2
*2018-11-27*
- Add sendSmsToSquad to NotificationsUtils.
- Fix notifications rules for updates where updates API was not being called.
- Update message for SMS to use the place holder variables for squad mate names and veteran name.
- Fix life changes follow up notifications to always send on indicated life changes.
- Fix life changes follow up notifications to use the date time of 2000-01-01T00:00Z.
- Update getMoodScores to return a scoring value for each MOOD_FACES survey taken.

## Version 0.3.1
*2018-11-26*
- Implement purgeData API.
- Update Spanish notification titles for mood faces and digital assistant.
- Add rule for immediate help for low to medium suicide risk transition.
- Update notification rules to send `DIGITAL_ASSISTANT` notifications once per 14 days period.
- Add `timestamp` field to ScoreRequestData.
- Add `employed` boolean to RiskAssessment.
- Update employability-rules to handle `employed` boolean.
- Improve print output for employability-rules. 
- Add notification utility function to generate `DIGITAL_ASSISTANT` notifications.
- Refactor rule inserting PreviousRisk to do conditional checks in LHS of rule.
- Refactor notifications rules to handle insertion of three or more RiskAssessments.
- Change path for REST APIs to http://IP_ADDRESS:5500/risk-service/
- Refactor getRiskAssessments to include parameter to limit the number of RiskAssessment results from MongoDB.
- Add `IMMEDIATE_HELP` notifications.

## Version 0.3.0
*2018-11-20*
- Add positive `FEEDBACK` notifications.
- Add `DIGITAL_ASSISTANT` notifications.
- Add -5 second adjustment to notifications.
- Add 30-day mood mean computation.
- Add extra enumerations to Category class to handle mood and sentiment scoring.
- Update README with testing environment and references documentation.
- Add many more JSON test files.
- Update social-rules to use more consistent print output.
- Add CHANGELOG
