package com.ibm.grit.scoring;

import java.io.Serializable;

public class Health implements Serializable {

    private static final long serialVersionUID = -3845845262566341036L;
    public static final int FALSE = 0;
    public static final int TRUE = 1;
    
    public String personId;
    
    public int activity;
    public static final int SEDENTARY = 1;
    public static final int LIGHTLY_ACTIVE = 2;
    public static final int MEDIUM_ACTIVE = 3;
    public static final int ACTIVE = 4;
    public static final int VERY_ACTIVE = 5;
    
    public int noAccessToHealthServices;
    public int insurance;
    public int doctor;
    public int healthServices;
    public int vaHealthServices;
    
    // chronic conditions
    public int noChronicConditions;
    public int cardiovascularDisease;
    public int diabetes;
    public int cancer;
    public int obesity;
    public int arthritis;
    public int asthma;
    public int stroke;
    public int hypertension;
    public int smokingAlcohol;
    public int disability;
    
    public int compliance;
    public static final int NO_MEDS = 1;
    public static final int ALWAYS_TAKE = 2;
    public static final int USUALLY_TAKE = 3;
    public static final int OFTEN_FORGET_OR_MISS = 4;
    public static final int NEVER_TAKE = 5;
    
    public int activityRefuse;
    public int accessRefuse;
    public int chronicConditionRefuse;
    public int complianceRefuse;
    
    public Health() {
    	super();
    }

    public String getPersonId() {
        return personId;
    }

    public void setPersonId(String personId) {
        this.personId = personId;
    }

    public int getActivity() {
        return activity;
    }

    public void setActivity(int activity) {
        this.activity = activity;
    }

    public int getNoAccessToHealthServices() {
        return noAccessToHealthServices;
    }

    public void setNoAccessToHealthServices(int noAccessToHealthServices) {
        this.noAccessToHealthServices = noAccessToHealthServices;
    }

    public int getInsurance() {
        return insurance;
    }

    public void setInsurance(int insurance) {
        this.insurance = insurance;
    }

    public int getDoctor() {
        return doctor;
    }

    public void setDoctor(int doctor) {
        this.doctor = doctor;
    }

    public int getHealthServices() {
        return healthServices;
    }

    public void setHealthServices(int healthServices) {
        this.healthServices = healthServices;
    }

    public int getVaHealthServices() {
        return vaHealthServices;
    }

    public void setVaHealthServices(int vaHealthServices) {
        this.vaHealthServices = vaHealthServices;
    }

    public int getNoChronicConditions() {
        return noChronicConditions;
    }

    public void setNoChronicConditions(int noChronicConditions) {
        this.noChronicConditions = noChronicConditions;
    }

    public int getCardiovascularDisease() {
        return cardiovascularDisease;
    }

    public void setCardiovascularDisease(int cardiovascularDisease) {
        this.cardiovascularDisease = cardiovascularDisease;
    }

    public int getDiabetes() {
        return diabetes;
    }

    public void setDiabetes(int diabetes) {
        this.diabetes = diabetes;
    }

    public int getCancer() {
        return cancer;
    }

    public void setCancer(int cancer) {
        this.cancer = cancer;
    }

    public int getObesity() {
        return obesity;
    }

    public void setObesity(int obesity) {
        this.obesity = obesity;
    }

    public int getArthritis() {
        return arthritis;
    }

    public void setArthritis(int arthritis) {
        this.arthritis = arthritis;
    }

    public int getAsthma() {
        return asthma;
    }

    public void setAsthma(int asthma) {
        this.asthma = asthma;
    }

    public int getStroke() {
        return stroke;
    }

    public void setStroke(int stroke) {
        this.stroke = stroke;
    }

    public int getHypertension() {
        return hypertension;
    }

    public void setHypertension(int hypertension) {
        this.hypertension = hypertension;
    }

    public int getSmokingAlcohol() {
        return smokingAlcohol;
    }

    public void setSmokingAlcohol(int smokingAlcohol) {
        this.smokingAlcohol = smokingAlcohol;
    }

    public int getDisability() {
        return disability;
    }

    public void setDisability(int disability) {
        this.disability = disability;
    }

    public int getCompliance() {
        return compliance;
    }

    public void setCompliance(int compliance) {
        this.compliance = compliance;
    }

    public int getActivityRefuse() {
        return activityRefuse;
    }

    public void setActivityRefuse(int activityRefuse) {
        this.activityRefuse = activityRefuse;
    }

    public int getAccessRefuse() {
        return accessRefuse;
    }

    public void setAccessRefuse(int accessRefuse) {
        this.accessRefuse = accessRefuse;
    }

    public int getChronicConditionRefuse() {
        return chronicConditionRefuse;
    }

    public void setChronicConditionRefuse(int chronicConditionRefuse) {
        this.chronicConditionRefuse = chronicConditionRefuse;
    }

    public int getComplianceRefuse() {
        return complianceRefuse;
    }

    public void setComplianceRefuse(int complianceRefuse) {
        this.complianceRefuse = complianceRefuse;
    }
}
