package com.ibm.grit.scoring;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

public class Weights implements Serializable {
	
    /**
     * 
     */
    private static final long serialVersionUID = 2608017723680991606L;
    public Map<String, Double> weights = new HashMap<String, Double>();
    public Category cat;

    public Weights() {
            super();
    }

    public Weights(Map<String, Double> weights, Category cat) {
        this.weights = weights;
        this.cat = cat;
    }
    

    public double sumWeights() {
        double sum = 0;
        for (double value : getWeights().values()) {
                sum += value;
        }
        return sum;
    }

    public void normalizeWeights() {
        double s = sumWeights();
        while (Math.abs(s - 1.0) > 0.001) {
                double coeff = 1.0 / s;
                getWeights().replaceAll((key, value) -> coeff * value);
                s = sumWeights();
        }
    }

    /**
     * @return the weights
     */
    public Map<String, Double> getWeights() {
        return weights;
    }

    /**
     * @param weights the weights to set
     */
    public void setWeights(Map<String, Double> weights) {
        this.weights = weights;
    }

    /**
     * @return the cat
     */
    public Category getCat() {
        return cat;
    }

    /**
     * @param cat the cat to set
     */
    public void setCat(Category cat) {
        this.cat = cat;
    }
	
}
