package com.ibm.grit.rest;

import com.google.gson.Gson;
import com.mongodb.ConnectionString;
import com.mongodb.MongoClientSettings;
import com.mongodb.client.MongoClients;

import static org.bson.codecs.configuration.CodecRegistries.fromProviders;
import static org.bson.codecs.configuration.CodecRegistries.fromRegistries;

import java.io.IOException;
import java.util.Date;

import org.bson.codecs.configuration.CodecRegistry;
import org.bson.codecs.pojo.PojoCodecProvider;

import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

public class ManualClientTest {
    public static final MediaType JSON = MediaType.get("application/json; charset=utf-8");

    OkHttpClient client = new OkHttpClient();

    String post(String url, String json) throws IOException {
      RequestBody body = RequestBody.create(JSON, json);
      Request request = new Request.Builder()
          .url(url)
          .post(body)
          .build();
      try (Response response = client.newCall(request).execute()) {
        return response.body().string();
      }
    }

    public static void main(String[] args) throws IOException {
        Gson gson = new Gson();
        ManualClientTest example = new ManualClientTest();
        
        Notification notification = new Notification();
        notification.vetId = "MANUAL_CLIENT_TEST_ID";
        notification.notificationId = "LIFE_CHANGES";
        notification.effectiveDate = new Date();
        notification.title.en = "Life changes question";
        notification.title.es = "Spanish title";
        notification.description.en = "Ask the life changes question";
        notification.description.es = "Spanish description";
        notification.metadata = "METADATA";
        notification.systemNotification = true;
        notification.notificationType = "LIFE_CHANGE";
        
        String notificationJson = gson.toJson(notification);
        
        String baseUrl = "http://169.62.10.213";
        String port = ":5080";
        String path = "/internal/notifications/createNotification";
        
        String response = example.post(baseUrl + port + path, notificationJson);
        System.out.println(response);
    }
}
