package com.ibm.grit.scoring;

import org.kie.api.KieServices;
import org.kie.api.event.rule.DebugAgendaEventListener;
import org.kie.api.event.rule.DebugRuleRuntimeEventListener;
import org.kie.api.logger.KieRuntimeLogger;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.StatelessKieSession;

import com.ibm.grit.utils.ScoringUtils;

public class ManualBasicNeedsTest {
	
	public static final void main(final String[] args) {
        // KieServices is the factory for all KIE services 
        KieServices ks = KieServices.Factory.get();
        
        // From the kie services, a container is created from the classpath
        KieContainer kc = ks.getKieClasspathContainer();

        // From the container, a session is created based on
        // its definition and configuration in the META-INF/kmodule.xml file
        KieSession ksession = kc.newKieSession("BasicNeedsKS");

        // The application can also setup listeners
        //ksession.addEventListener( new DebugAgendaEventListener() );
        //ksession.addEventListener( new DebugRuleRuntimeEventListener() );

        // To setup a file based audit logger, uncomment the next line
        // KieRuntimeLogger logger = ks.getLoggers().newFileLogger( ksession, "manualtest" );

        // To setup a ThreadedFileLogger, so that the audit view reflects events whilst debugging,
        // uncomment the next line
        // KieRuntimeLogger logger = ks.getLoggers().newThreadedFileLogger( ksession, "./helloworld", 1000 );

        // The application can insert facts into the session
        BasicNeeds bn = new BasicNeeds();
        RiskAssessment riskAssessment = new RiskAssessment();
        riskAssessment.personId = "TEST_ID";
        
        // Basic Needs
        bn.personId = "TEST_ID";
        bn.sex = BasicNeeds.MALE;
        bn.housing = BasicNeeds.OWN;
        bn.transp = BasicNeeds.UNRELIABLE;
        bn.food = BasicNeeds.OFTEN_HUNGRY;
        bn.finan = BasicNeeds.ONE_TO_TWO;
        
        // Insert facts
        ksession.insert(bn);
        ksession.insert(riskAssessment);
        
        // and fire the rules
        ksession.fireAllRules();

        // Remove comment if using logging
        // logger.close();

        // and then dispose the session
        ksession.dispose();
    }

}