package com.ibm.grit.scoring;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

import org.kie.api.KieServices;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;

import com.ibm.grit.utils.ScoringUtils;

public class ManualHealthTest {

	public static final void main(final String[] args) {
        // KieServices is the factory for all KIE services 
        KieServices ks = KieServices.Factory.get();
        
        // From the kie services, a container is created from the classpath
        KieContainer kc = ks.getKieClasspathContainer();

        // From the container, a session is created based on
        // its definition and configuration in the META-INF/kmodule.xml file
        KieSession ksession = kc.newKieSession("HealthKS");

        // The application can also setup listeners
        //ksession.addEventListener( new DebugAgendaEventListener() );
        //ksession.addEventListener( new DebugRuleRuntimeEventListener() );

        // To setup a file based audit logger, uncomment the next line
        // KieRuntimeLogger logger = ks.getLoggers().newFileLogger( ksession, "manualtest" );

        // To setup a ThreadedFileLogger, so that the audit view reflects events whilst debugging,
        // uncomment the next line
        // KieRuntimeLogger logger = ks.getLoggers().newThreadedFileLogger( ksession, "./helloworld", 1000 );

        // The application can insert facts into the session
        BasicNeeds bn = new BasicNeeds();
        Employment emp = new Employment();
        Health hea = new Health();
        Military mil = new Military();
        Mental ment = new Mental();
        Social soc = new Social();
        RiskAssessment riskAssessment = new RiskAssessment();
        
        bn.personId = "TEST_ID";
        emp.personId = "TEST_ID";
        hea.personId = "TEST_ID";
        mil.personId = "TEST_ID";
        ment.personId = "TEST_ID";
        soc.personId = "TEST_ID";
        riskAssessment.personId = "TEST_ID";
        
        /*
        hea.cardiovascularDisease = false;
        hea.diabetes = false;
        hea.cancer = false;
        hea.obesity = false;
        hea.arthritis = false;
        hea.asthma = false;
        hea.stroke = false;
        hea.hypertension = false;
        hea.smokingAlcohol = false;
        hea.disability = false;
        
        hea.activity = Health.SEDENTARY;
        
        hea.noAccessToHealthServices = false;
        hea.insurance = true;
        hea.doctor = true;
        hea.healthServices = true;
        
        hea.compliance = Health.NO_MEDS;
        */
        
        ScoringUtils su = new ScoringUtils();
        //su.minRiskFemale(bn, emp, hea, ment, mil, soc);
        su.lowRiskMale(bn, emp, hea, ment, mil, soc, riskAssessment);
        //su.mediumRiskFemale(bn, emp, hea, ment, mil, soc);
        //su.highRiskMale(bn, emp, hea, ment, mil, soc);
        //su.maxRiskMale(bn, emp, hea, ment, mil, soc);
        
        // Stateful execution
        ksession.insert(hea);
        ksession.insert(riskAssessment);
        
        // and fire the rules
        ksession.fireAllRules();

        // Remove comment if using logging
        // logger.close();

        // and then dispose the session
        ksession.dispose();
        
		
    }

}
