/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ibm.grit.scoring;

import com.ibm.grit.utils.ScoringUtils;
import org.kie.api.KieServices;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;

/**
 *
 * @author swac
 */
public class ManualMultiPerson {
    public static final void main(final String[] args) {
		// KieServices is the factory for all KIE services 
        KieServices ks = KieServices.Factory.get();
        
        // From the kie services, a container is created from the classpath
        KieContainer kc = ks.getKieClasspathContainer();

        // From the container, a session is created based on
        // its definition and configuration in the META-INF/kmodule.xml file
        KieSession ksession = kc.newKieSession("SocialKS");

        // The application can also setup listeners
        //ksession.addEventListener( new DebugAgendaEventListener() );
        //ksession.addEventListener( new DebugRuleRuntimeEventListener() );

        // To setup a file based audit logger, uncomment the next line
        // KieRuntimeLogger logger = ks.getLoggers().newFileLogger( ksession, "manualtest" );

        // To setup a ThreadedFileLogger, so that the audit view reflects events whilst debugging,
        // uncomment the next line
        // KieRuntimeLogger logger = ks.getLoggers().newThreadedFileLogger( ksession, "./helloworld", 1000 );

        BasicNeeds bnLow = new BasicNeeds();
        Employment empLow = new Employment();
        Health heaLow = new Health();
        Military milLow = new Military();
        Mental mentLow = new Mental();
        Social socLow = new Social();
        RiskAssessment lowRiskMale = new RiskAssessment();
        lowRiskMale.personId = "LOW_RISK_MALE";
        
        BasicNeeds bnMed = new BasicNeeds();
        Employment empMed = new Employment();
        Health heaMed = new Health();
        Military milMed = new Military();
        Mental mentMed = new Mental();
        Social socMed = new Social();
        RiskAssessment mediumRiskFemale = new RiskAssessment();
        mediumRiskFemale.personId = "MEDIUM_RISK_FEMALE";
        
        BasicNeeds bnHi = new BasicNeeds();
        Employment empHi = new Employment();
        Health heaHi = new Health();
        Military milHi = new Military();
        Mental mentHi = new Mental();
        Social socHi = new Social();
        RiskAssessment highRiskMale = new RiskAssessment();
        highRiskMale.personId = "HIGH_RISK_MALE";
        
        ScoringUtils su = new ScoringUtils();
        //su.maxRiskMale(bn, emp, hea, ment, mil, soc);
        su.highRiskMale(bnHi, empHi, heaHi, mentHi, milHi, socHi, highRiskMale);
        su.mediumRiskFemale(bnMed, empMed, heaMed, mentMed, milMed, socMed, mediumRiskFemale);
        su.lowRiskMale(bnLow, empLow, heaLow, mentLow, milLow, socLow, lowRiskMale);
        //su.minRiskFemale(bn, emp, hea, ment, mil, soc);
                
        // Stateful execution
        /*
        ksession.insert(bnLow);
        ksession.insert(empLow);
        ksession.insert(heaLow);
        ksession.insert(milLow);
        ksession.insert(mentLow);
        ksession.insert(socLow);
        ksession.insert(lowRiskMale);
        */
        
        ksession.insert(bnMed);
        ksession.insert(empMed);
        ksession.insert(heaMed);
        ksession.insert(milMed);
        ksession.insert(mentMed);
        ksession.insert(socMed);
        ksession.insert(mediumRiskFemale);
        
        /*
        ksession.insert(bnHi);
        ksession.insert(empHi);
        ksession.insert(heaHi);
        ksession.insert(milHi);
        ksession.insert(mentHi);
        ksession.insert(socHi);
        ksession.insert(highRiskMale);
        */
        // and fire the rules
        ksession.fireAllRules();

        // Remove comment if using logging
        // logger.close();

        // and then dispose the session
        ksession.dispose();
    }
    
}
