package com.ibm.grit.scoring;

import org.kie.api.KieServices;
import org.kie.api.event.rule.DebugAgendaEventListener;
import org.kie.api.event.rule.DebugRuleRuntimeEventListener;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;

import com.ibm.grit.utils.ScoringUtils;

public class ManualSocialTest {

	public static final void main(final String[] args) {
        // KieServices is the factory for all KIE services 
        KieServices ks = KieServices.Factory.get();
        
        // From the kie services, a container is created from the classpath
        KieContainer kc = ks.getKieClasspathContainer();

        // From the container, a session is created based on
        // its definition and configuration in the META-INF/kmodule.xml file
        KieSession ksession = kc.newKieSession("SocialKS");

        // The application can also setup listeners
        ksession.addEventListener( new DebugAgendaEventListener() );
        ksession.addEventListener( new DebugRuleRuntimeEventListener() );

        // To setup a file based audit logger, uncomment the next line
        // KieRuntimeLogger logger = ks.getLoggers().newFileLogger( ksession, "manualtest" );

        // To setup a ThreadedFileLogger, so that the audit view reflects events whilst debugging,
        // uncomment the next line
        // KieRuntimeLogger logger = ks.getLoggers().newThreadedFileLogger( ksession, "./helloworld", 1000 );

        // The application can insert facts into the session
        BasicNeeds bn = new BasicNeeds();
        Employment emp = new Employment();
        Health hea = new Health();
        Military mil = new Military();
        Mental ment = new Mental();
        Social soc = new Social();
        RiskAssessment riskAssessment = new RiskAssessment();
        
        ScoringUtils su = new ScoringUtils();
        //su.lowRiskMale(bn, emp, hea, ment, mil, soc);
        //su.mediumRiskFemale(bn, emp, hea, ment, mil, soc);
        su.highRiskMale(bn, emp, hea, ment, mil, soc, riskAssessment);
        
        // Social
        /*
        soc.marital = Social.DIVORCED;
        soc.moMaritalChg = 6;        
        soc.interact = Social.NONE_OR_RARELY;        
        soc.conflict = Social.FREQUENT_OR_REGULAR;        
        soc.relig = Social.UP_TO_2X_PER_YEAR;
        soc.edu = Social.PARTIAL_HIGH_SCHOOL;
        */
        
        // Insert facts
        ksession.insert(soc);
        ksession.insert(riskAssessment);
        
        // and fire the rules
        ksession.fireAllRules();

        // Remove comment if using logging
        // logger.close();

        // and then dispose the session
        ksession.dispose();
    }

}
