package com.ibm.grit.scoring;

import org.kie.api.KieServices;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;

import com.ibm.grit.utils.ScoringUtils;

public class ManualSuicideTest {

	public static final void main(final String[] args) {
        // KieServices is the factory for all KIE services 
        KieServices ks = KieServices.Factory.get();
        
        // From the kie services, a container is created from the classpath
        KieContainer kc = ks.getKieClasspathContainer();

        // From the container, a session is created based on
        // its definition and configuration in the META-INF/kmodule.xml file
        KieSession ksession = kc.newKieSession("SuicideKS");

        // The application can also setup listeners
        //ksession.addEventListener( new DebugAgendaEventListener() );
        //ksession.addEventListener( new DebugRuleRuntimeEventListener() );

        // To setup a file based audit logger, uncomment the next line
        // KieRuntimeLogger logger = ks.getLoggers().newFileLogger( ksession, "manualtest" );

        // To setup a ThreadedFileLogger, so that the audit view reflects events whilst debugging,
        // uncomment the next line
        // KieRuntimeLogger logger = ks.getLoggers().newThreadedFileLogger( ksession, "./helloworld", 1000 );

        // The application can insert facts into the session
        BasicNeeds bn = new BasicNeeds();
        Employment emp = new Employment();
        Health hea = new Health();
        Military mil = new Military();
        Mental ment = new Mental();
        Social soc = new Social();
        RiskAssessment riskAssessment = new RiskAssessment();
        
        bn.personId = "TEST_ID";
        emp.personId = "TEST_ID";
        hea.personId = "TEST_ID";
        mil.personId = "TEST_ID";
        ment.personId = "TEST_ID";
        soc.personId = "TEST_ID";
        riskAssessment.personId = "TEST_ID";
        
        
        bn.sex = BasicNeeds.MALE;
        
        ment.depression = Mental.FALSE;
        ment.anxiety = Mental.TRUE;
        ment.ptsd = Mental.FALSE;
        ment.otherMentDiagnosis = Mental.FALSE;
        
        ment.weeklyAlcoholDrinks = 0;
        
        ment.tobaccoVape = Mental.FALSE;
        ment.opioids = Mental.FALSE;
        ment.cannabis = Mental.FALSE;
        ment.amphetamine = Mental.FALSE;
        ment.cocaine = Mental.FALSE;
        ment.heroin = Mental.FALSE;
        ment.otherSubstAbuse = Mental.FALSE;
        
        ment.antidepressants = Mental.FALSE;
        ment.sleepMeds = Mental.FALSE;
        ment.otherMentMeds = Mental.FALSE;
        
        //ment.annualMentVisits = 1;
        ment.annualMentVisits2 = Mental.ONE_TO_SIX;
        
        mil.reductRank = Military.NO;
        mil.dischType = Military.HONORABLE;
        
        soc.marital = Social.SINGLE;
        soc.moMaritalChg = 0;
        
        
        ScoringUtils su = new ScoringUtils();
        //su.maxRiskMale(bn, emp, hea, ment, mil, soc);
        //su.highRiskMale(bn, emp, hea, ment, mil, soc);
        //su.mediumRiskFemale(bn, emp, hea, ment, mil, soc, riskAssessment);
        //su.lowRiskMale(bn, emp, hea, ment, mil, soc);
        //su.minRiskFemale(bn, emp, hea, ment, mil, soc);
                
        // Stateful execution
        ksession.insert(bn);
        ksession.insert(emp);
        ksession.insert(hea);
        ksession.insert(mil);
        ksession.insert(ment);
        ksession.insert(soc);
        ksession.insert(riskAssessment);
        
        // and fire the rules
        ksession.fireAllRules();

        // Remove comment if using logging
        // logger.close();

        // and then dispose the session
        ksession.dispose();
        
    }

}
