package com.ibm.grit.scoring;


import org.kie.api.KieServices;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.StatelessKieSession;

import com.ibm.grit.utils.ScoringUtils;

import org.kie.api.event.rule.DebugAgendaEventListener;
import org.kie.api.event.rule.DebugRuleRuntimeEventListener;
import org.kie.api.logger.KieRuntimeLogger;

import java.util.Iterator;
import java.util.Set;

public class ManualTest {
	
	public static final void main(final String[] args) {
		// KieServices is the factory for all KIE services 
        KieServices ks = KieServices.Factory.get();
        
        // From the kie services, a container is created from the classpath
        KieContainer kc = ks.getKieClasspathContainer();

        // From the container, a session is created based on
        // its definition and configuration in the META-INF/kmodule.xml file
        KieSession ksession = kc.newKieSession("AllKS");

        // The application can also setup listeners
        //ksession.addEventListener( new DebugAgendaEventListener() );
        //ksession.addEventListener( new DebugRuleRuntimeEventListener() );

        // To setup a file based audit logger, uncomment the next line
        // KieRuntimeLogger logger = ks.getLoggers().newFileLogger( ksession, "manualtest" );

        // To setup a ThreadedFileLogger, so that the audit view reflects events whilst debugging,
        // uncomment the next line
        // KieRuntimeLogger logger = ks.getLoggers().newThreadedFileLogger( ksession, "./helloworld", 1000 );

        // The application can insert facts into the session
        BasicNeeds bn = new BasicNeeds();
        Employment emp = new Employment();
        Health hea = new Health();
        Military mil = new Military();
        Mental ment = new Mental();
        Social soc = new Social();
        RiskAssessment riskAssessment = new RiskAssessment();
        
        /*
        bn.sex = BasicNeeds.MALE;
        
        ment.depression = false;
        ment.manicDepression = false;
        ment.PTSD = false;
        ment.otherMentDiagnosis = true;
        
        ment.weeklyAlcoholDrinks = 0;
        
        ment.tobaccoVape = false;
        ment.opioids = false;
        ment.cannabis = false;
        ment.amphetamine = false;
        ment.cocaine = false;
        ment.heroin = false;
        ment.otherSubstAbuse = false;
        
        ment.antidepressants = false;
        ment.sleepMeds = false;
        ment.otherMentMeds = false;
        
        ment.annualMentVisits = 1;
        
        mil.reductRank = Military.NO;
        mil.dischType = Military.HONORABLE;
        
        soc.marital = Social.SINGLE;
        soc.moMaritalChg = 0;
        */
        
        ScoringUtils su = new ScoringUtils();
        //su.maxRiskMale(bn, emp, hea, ment, mil, soc);
        //su.highRiskMale(bn, emp, hea, ment, mil, soc);
        //su.mediumRiskFemale(bn, emp, hea, ment, mil, soc);
        su.lowRiskMale(bn, emp, hea, ment, mil, soc, riskAssessment);
        //su.minRiskFemale(bn, emp, hea, ment, mil, soc);
                
        // Stateful execution
        ksession.insert(bn);
        ksession.insert(emp);
        ksession.insert(hea);
        ksession.insert(mil);
        ksession.insert(ment);
        ksession.insert(soc);
        ksession.insert(riskAssessment);
        
        // and fire the rules
        ksession.fireAllRules();

        // Remove comment if using logging
        // logger.close();

        // and then dispose the session
        ksession.dispose();
    }

}
