'use strict';

const yargs = require('yargs');
const fs = require('fs');
const path = require('path');
var JSONStream = require('JSONStream');

const argv = yargs
	.options({
		a: {
			demand: true,
			alias: 'addFile',
			describe: 'file with all jobs to be added',
			string: true
        },
        d: {
            demand: true,
            alias: 'deleteFile',
            describe: 'file with jobs to be removed',
            string: true
        }
	})
	.help()
	.alias('help', 'h')
    .argv;


var naicsCodesCount = 0;
var noTitleCount = 0;
var noTextCount = 0;
var totalCount = "";

var stream = fs.createReadStream(argv.addFile);
stream.pipe(JSONStream.parse('*')).on('data', function (data) {
    
    if (!data.counter) {
        var naicsSub2 = data.ConsolidatedInferredNAICS.substring(0,2);
        var naicsSub3 = data.ConsolidatedInferredNAICS.substring(0,3);
        var industryCode = ["23", "48", "49", "31", "32", "33", "54", "55", "56", "518", "519"];
        if (data.ConsolidatedInferredNAICS !== undefined && (industryCode.includes(naicsSub2) === true || industryCode.includes(naicsSub3) === true)) {
            naicsCodesCount ++;
        }
        if (data.CanonJobTitle == "") {
            noTitleCount ++;
        }
        if (data.JobText == "") {
            noTextCount ++;
        }
    } else if (data.counter) {
        totalCount = data.counter;
    }  
    
});

stream.on('end', function () {
    var delJobsCount = 0;
    var dailyRemoveData = fs.readFileSync(argv.deleteFile);
    var deleteData = JSON.parse(dailyRemoveData);

    var file = path.basename(argv.addFile);
    console.log(file);

    deleteData.forEach(job => {
        if (!job.counter) {
            delJobsCount ++;
        }
    });

    var fileName = path.basename(argv.addFile);
    var date = fileName.split("_")[1].split(".")[0];

    var JobSummary = {
        "Total_AddJobs_Count": totalCount,
        "Jobs_in_industires": naicsCodesCount,
        "Jobs_no_Title": noTitleCount,
        "Jobs_no_Text": noTextCount,
        "Total_AddJobs_Excluded": totalCount - (naicsCodesCount + noTitleCount + noTextCount),
        "Delete_Jobs": delJobsCount,
        "JobFeed_Date": date
    };
    console.log("JobSummary", JobSummary);
    var today = new Date().toISOString().split('T')[0].replace(/\-/g, "");
    fs.writeFileSync(`./BGDailyFeed/reports/JobSummary_${today}.json`, JSON.stringify(JobSummary));
});










