'use strict';

const Predicate = require("./predicate");

module.exports = class QuestionSet {

    constructor(questionSetId, version, orderNum) {
        this.questionSetId = questionSetId.trim();
        this.version = parseInt(version);
        this.orderNum = parseInt(orderNum);
        this.questionSet = [];
        this.predicate = { };
    }

    addQuestion(questionId) {
        this.questionSet.push(questionId.trim());
    }

    addPredicate(predicateString) {
        if (predicateString && predicateString.trim().length > 0) {
            let tokens = Predicate.tokenize(predicateString);
            this.predicate = new Predicate(tokens);
        }
    }
    
}


