'use strict';

exports.constants = function(app) {

  console.log("CONSTANTS - ENVIRONMENT VARIABLE -  process.env.NODE_ENV: ", process.env.NODE_ENV);

  //Normal Docker Variables
  var constants = {
    mongo: {
      dbName: process.env.MONGO_VAGRIT_DB_NAME,
      user: process.env.MONGO_INITDB_ROOT_USERNAME,
      pass: process.env.MONGO_INITDB_ROOT_PASSWORD,
      host: process.env.MONGO_HOST,
      hostB: process.env.MONGO_HOST_B,
      port: process.env.MONGO_PORT,
      replicaSet: process.env.MONGO_REPLICASET,
      useSsl: process.env.MONGO_USE_SSL,
      authSource: process.env.MONGO_AUTH_SOURCE,
      url: ""
    },
    cognitive: {
      carlaUrl: "http://"+process.env.COGNITIVE_CARLA_URL+":"+process.env.COGNITIVE_CARLA_PORT+"/ConversationAPI/api/v1/workspaces/message/?workspace_id="+process.env.COGNITIVE_CARLA_WORKSPACE_ID,
      blueTasServer: "http://"+process.env.COGNITIVE_BLUETAS_URL+":"+process.env.COGNITIVE_BLUETAS_PORT+"/BluetasAPI/api/v1/",
      blueTasCollectionId: process.env.COGNITIVE_BLUETAS_COLLECTION_ID,
      wemServerBaseUrl: "http://"+process.env.COGNITIVE_WEM_URL+":"+process.env.COGNITIVE_WEM_PORT+"/api/",
      riskServer: "http://"+process.env.COGNITIVE_RISK_URL+":"+process.env.COGNITIVE_RISK_PORT+"/risk-service/",
      jobSearchNumberOfResultToRetrieve: process.env.COGNITIVE_NUMBER_OF_JOB_SEARCH_RESULTS
    },
    twilio: {
      accountSid: process.env.TWILIO_ACCOUNT_SID,
      authToken: process.env.TWILIO_AUTH_TOKEN,
      fromPhoneNumber: process.env.TWILIO_FROM_PHONE_NUMBER
    },
    sendgrid: {
      apiId:  process.env.SENDGRID_API_ID,
      apiKey:  process.env.SENDGRID_API_KEY,
      fromEmail: process.env.SENDGRID_FROM_EMAIL
    },
    appStores: {
      googlePlayLink: "",
      appleAppStoreLink: "",
      appStoreLink: ""
    },


    accepted: "ACCEPTED",
    pending: "PENDING",
    testEmailExtension: ".test",
    localServerEnv: "local",
    devServerEnv: "dev",
    prodServerEnv: "prod"


  };

  /*
  //For Local Host Developing - Not using Docker
  if (process.env.NODE_ENV === "local") {
    constants.mongo.host = "localhost"
  }
  */

  //Set up Mongo Url
  //var mongoUrl = "mongodb://username:password@localhost:27017/";//Localhost
  
  //Dev
  constants.mongo.url = "mongodb://"+constants.mongo.user+":"+constants.mongo.pass+"@"+constants.mongo.host+":"+constants.mongo.port+","+constants.mongo.hostB+":"+constants.mongo.port+"/"+constants.mongo.dbName+"?replicaSet="+constants.mongo.replicaSet+"&ssl="+constants.mongo.useSsl+"&authSource="+constants.mongo.authSource;
  
  //Local - With Docker Network
  if (process.env.NODE_ENV === "local") {
    //mongoUrl = "mongodb://username:password@va-grit-midtier-mongo-db:27017/";//Docker Network
    constants.mongo.url = "mongodb://"+constants.mongo.user+":"+constants.mongo.pass+"@"+constants.mongo.host+":"+constants.mongo.port+"/";
  }
  
  //Local - No Docker - Do Not set NODE_ENV on local machine
  if (constants.mongo.user === undefined || constants.mongo.user === null || constants.mongo.user === "") {
    constants.mongo.url = "mongodb://localhost:27017/";//Localhost for developing
  }
  
  //console.log("CONSTANTS - constants: ", constants);
  return constants;

};
