'use strict';

var app = require('../../server/server');
const VaGrit = require('va-grit-microservices');
var responseBuilder = require('va-grit-microservices/response/responseBuilder');

module.exports = function(Flags) {

  Flags.updateFlags = function(body, cb) {
   var response = responseBuilder.createResponseObject();
   var errorMessage;

   
   //Required fields check 
   if (body === undefined || body === null 
         || body.vetId === undefined || body.vetId === null || body.vetId === ""
         || body.currentSessionFlags === undefined || body.currentSessionFlags === null || body.currentSessionFlags.length === 0) {
     errorMessage = "Missing Required fields or values";
     responseBuilder.setInvalidRequestStatus(response, errorMessage);
     cb(null,response);
     return;
   }
   
   //console.log("****Start of Flags.updateFlags.  body: ", JSON.stringify(body));


   var flag = app.models.flag;

   var updateFlag = new Object();
   updateFlag.vetId = body.vetId;
   updateFlag.currentSessionFlags = body.currentSessionFlags;
   updateFlag.nextSessionFlags = body.nextSessionFlags;

   app.models.flag.upsert(updateFlag,
   function(err, updatedFlags) {
      if (err){
         var errorMessage = "flag upsertSert for vetId [" + body.vetId + "] resulted in an err" ;
         responseBuilder.setUnexpectedExceptionStatus(response, errorMessage);
         cb(err,null);
      }
      else {
        console.log("flag.upsert:", updateFlag);
        responseBuilder.setSuccessStatus(response);
        console.log("flags.upsert Response", response);
        cb(null,response);
      }
    });


  };  // Flags.updateFlags




  Flags.remoteMethod('updateFlags', {
      accepts: [{ arg: 'data', type: 'object', http: { source: 'body' } }],
      returns: {arg: 'response', type: 'string'},
      http: {path: '/updateFlags', verb: 'post'}
  });


};
