'use strict';
var app = require('../../server/server');

module.exports = function(Auditevent) {
  
  Auditevent.eventTypes = { 
    SIGN_UP: "SIGN_UP",
    GET_NOTIFICATIONS: "GET_NOTIFICATIONS",
    RESOLVE_NOTIFICATION: "RESOLVE_NOTIFICATION",
    CREATE_NOTIFICATION: "CREATE_NOTIFICATION",
    UPDATE_NOTIFICATION: "UPDATE_NOTIFICATION",
    DELETED_ACCOUNT: "DELETED_ACCOUNT",
    SURVEY_COMPLETE: "SURVEY_COMPLETE",
    SURVEY_ABORTED: "SURVEY_ABORTED",
    SENT_SMS_TO_SQUAD: "SENT_SMS_TO_SQUAD",
    ADD_SQUAD_MATE: "ADD_SQUAD_MATE",
    REMOVE_SQUAD_MATE: "REMOVE_SQUAD_MATE",
    ADD_SOCIAL_MEDIA_HANDLE: "ADD_SOCIAL_MEDIA_HANDLE",
    UPDATE_SOCIAL_MEDIA_HANDLE: "UPDATE_SOCIAL_MEDIA_HANDLE",
    REMOVE_SOCIAL_MEDIA_HANDLE: "REMOVE_SOCIAL_MEDIA_HANDLE",
    UPLOAD_RESUME_INFO: "UPLOAD_RESUME_INFO",
    SAVE_JOB: "SAVE_JOB",
    DELETE_JOB: "DELETE_JOB",
    SEARCH_JOBS: "SEARCH_JOBS",
    SEARCH_SKILLS: "SEARCH_SKILLS"
  };
  
  //This will save an Audit Event.  This function does NOT return a response.
  Auditevent.addEvent = function(request) {
    try {
    
     //console.log("**** Starting Auditevent.addEvent. request: ", request);
     
     if (request.vetId !== undefined && request.vetId !== null 
          && request.eventType !== undefined && request.eventType !== null) {
     
       var auditEvent = {
         vetId: request.vetId,
         eventType: request.eventType,
         detail: (request.detail != null && request.detail !== undefined) ? request.detail : {},   
         date: new Date()
       };
       
       app.models.auditEvent.create(auditEvent, function(err, createdAuditEvent) {
         if (err) {
            console.log("**** Starting Auditevent.addEvent. auditEvent.create err: ", err);
         }
       });
      
     }//END - Required fields check
     
    }
    catch(err) {
       console.log("****Auditevent.addEvent ERROR try catch err: ", err);
    }
     
  }// END Auditevent.addEvent
  
};
