# VA-GRIT Microservice - Job

The app is the job microservice for the docker-compose app.

This readme file will describe the set up for this environment to work with docker, docker-compose, and mongodb.

## Requirements
- Docker
- Docker Compose

# Uses Loopback
The project is generated by [LoopBack](http://loopback.io) with basic User auth.

# Change the port in server/config.json


# Add the different models for job

# Configure for mongodb

```
npm install loopback-connector-mongodb --save
```

Add the vaGritMidtierMongoDb to datasources.json - this will be the same database the other microservices are using
```
# server/datasources.json

"vaGritMidtierMongoDb": {
  "host": "db",
  "port": 27017,
  "url": "",
  "database": "vaGritMidtier",
  "password": "",
  "name": "vaGritMidtierMongoDb",
  "user": "",
  "connector": "mongodb"
}
```

# Configure for Docker

```
# Dockerfile

FROM node:8.11.3-onbuild
WORKDIR /app
## nodemon will restart server on changes, also need to mount volume in docker-compose.yml
RUN npm install -g nodemon
COPY . /app
RUN npm install
EXPOSE 5002
```
```
Also add to Docker-compose.yml in folder above
```

# Add APIs to Gateway
To add this microservice's API's to the gateway see gateway.config.yml:

```
../va-grit-midtier-gateway/config/gateway.config.yml
```

# Running with docker and docker-compose

This app is a microservice within a larger app. This project includes a Dockerfile in the root directory f this project that can be built and run on it's own via Docker CLI Commands, and together with other apps as defined in Docker-compose.yml in the folder above this project

## To Run all services via docker-compose
- Go to project root directory in console

### To Build, Run, and Observe in logs
```
docker-compose -p va-grit-midtier up
or
docker-compose -p va-grit-midtier up --force-recreate  --build  
```

### To Start all services
```
docker-compose -p va-grit-midtier start
```

### To Stop All services
```
docker-compose -p va-grit-midtier stop
```


# To Run on localhost for developing

This app includes a Docker file as is meant to work with docker-compose project.  

However, the project can be run from the root directory with:

```
npm start
```
- NOTE DEPENDENCY ISSUES COULD EXIST IF RUNNING LOCALLY AND NOT RUNNING IN THE DOCKER-COMPOSE APP, PARTICULARLY IF TRYING TO COMMUNICATE WITH OTHER APPS IN OR OUT OTHE DOCKER NETWORK AS CONNECTION CONFIGURATION OPTIONS WILL NO LONGER BE VALID. <b>DATASOURCE HOSTS CAN BE CHANGED IN DATASOURCES.JSON</b>
