// Version Sept 10, 2018

var StatusTypes = {
  SUCCESS: "SUCCESS",
  INVALID_REQUEST: "INVALID_REQUEST",
  LOGIN_FAILED : "LOGIN_FAILED",
  UNEXPECTED_EXCEPTION : "UNEXPECTED_EXCEPTION",
  INVALID_TOKEN: "INVALID_TOKEN",
  EMAIL_IN_USE: "EMAIL_IN_USE",
  OLD_PASSWORD_MISMATCH: "OLD_PASSWORD_MISMATCH",
  NO_QUESTIONS_AVAILABLE: "NO_QUESTIONS_AVAILABLE",
  SQUAD_MATES_MAX_REACHED: "SQUAD_MATES_MAX_REACHED",
  SQUAD_MATE_ALREADY_EXISTS: "SQUAD_MATE_ALREADY_EXISTS",
  HANDLE_NOT_VALID: "HANDLE_NOT_VALID",
  NOT_UNIQUE: "NOT_UNIQUE",
  TEMP_PASSWORD_MISMATCH: "TEMP_PASSWORD_MISMATCH",
  NO_WEM_PROFILE: "NO_WEM_PROFILE",
  EMAIL_NOT_FOUND: "EMAIL_NOT_FOUND"
};


function createResponseObject(){
  /*
  response = {
     payload: {
     },

     badgeAward "[]"

     status: {
       statusType: "",
       errorMessage: ""
     }
  } */
  var response = new Object();
  response.payload = new Object();
  response.badgeAward = new Array();
  response.status = new Object();
  response.status.statusType = "";
  response.status.errorMessage = "";
  return response;

}


function setSuccessStatus(response){
  response.status.statusType = StatusTypes.SUCCESS;
  response.status.errorMessage = "";
}

function setInvalidRequestStatus(response, errorMessage){
  response.status.statusType = StatusTypes.INVALID_REQUEST;
  response.status.errorMessage = errorMessage;
}

function setLoginFailedStatus(response, errorMessage){
  response.status.statusType = StatusTypes.LOGIN_FAILED;
  response.status.errorMessage = errorMessage;
}

function setUnexpectedExceptionStatus(response, errorMessage){
  response.status.statusType = StatusTypes.UNEXPECTED_EXCEPTION;
  response.status.errorMessage = errorMessage;
}

function setInvalidTokenStatus(response, token){
  response.status.statusType = StatusTypes.INVALID_TOKEN;
  response.status.errorMessage = "Invalid Token [" + token + "]";
}

function setEmailInUseStatus(response, errorMessage){
  response.status.statusType = StatusTypes.EMAIL_IN_USE;
  response.status.errorMessage = errorMessage;
}

function setOldPasswordDoesntMatchStatus(response, errorMessage){
  response.status.statusType = StatusTypes.OLD_PASSWORD_MISMATCH;
  response.status.errorMessage = errorMessage;
}


function setNoQuestionsAvailableStatus(response, errorMessage){
  response.status.statusType = StatusTypes.NO_QUESTIONS_AVAILABLE;
  response.status.errorMessage = errorMessage;
}

function setSquadMatesMaxReachedStatus(response, errorMessage){
  response.status.statusType = StatusTypes.SQUAD_MATES_MAX_REACHED;
  response.status.errorMessage = errorMessage;
}

function setSquadMatesAlreadyExistsStatus(response, errorMessage){
  response.status.statusType = StatusTypes.SQUAD_MATE_ALREADY_EXISTS;
  response.status.errorMessage = errorMessage;
}

function setSocialHandleNotValidStatus(response, errorMessage){
  response.status.statusType = StatusTypes.HANDLE_NOT_VALID;
  response.status.errorMessage = errorMessage;
}

function setSocialHandleNotUniqueStatus(response, errorMessage){
  response.status.statusType = StatusTypes.NOT_UNIQUE;
  response.status.errorMessage = errorMessage;
}

function setTempPasswordMismatchStatus(response, errorMessage){
  response.status.statusType = StatusTypes.TEMP_PASSWORD_MISMATCH;
  response.status.errorMessage = errorMessage;
}

function setNoWemProfileStatus(response, errorMessage){
  response.status.statusType = StatusTypes.NO_WEM_PROFILE;
  response.status.errorMessage = errorMessage;
}

function setEmailNotFoundStatus(response, errorMessage){
  response.status.statusType = StatusTypes.EMAIL_NOT_FOUND;
  response.status.errorMessage = errorMessage;
}



module.exports.createResponseObject = createResponseObject;
module.exports.setSuccessStatus = setSuccessStatus;
module.exports.setInvalidRequestStatus = setInvalidRequestStatus;
module.exports.setLoginFailedStatus = setLoginFailedStatus;
module.exports.setUnexpectedExceptionStatus = setUnexpectedExceptionStatus;
module.exports.setInvalidTokenStatus = setInvalidTokenStatus;
module.exports.StatusTypes = StatusTypes;
module.exports.setEmailInUseStatus = setEmailInUseStatus;
module.exports.setOldPasswordDoesntMatchStatus = setOldPasswordDoesntMatchStatus;
module.exports.setNoQuestionsAvailableStatus = setNoQuestionsAvailableStatus;
module.exports.setSquadMatesMaxReachedStatus = setSquadMatesMaxReachedStatus;
module.exports.setSquadMatesAlreadyExistsStatus = setSquadMatesAlreadyExistsStatus;
module.exports.setSocialHandleNotValidStatus = setSocialHandleNotValidStatus;
module.exports.setSocialHandleNotUniqueStatus = setSocialHandleNotUniqueStatus;
module.exports.setTempPasswordMismatchStatus = setTempPasswordMismatchStatus;
module.exports.setNoWemProfileStatus = setNoWemProfileStatus;
module.exports.setEmailNotFoundStatus = setEmailNotFoundStatus;
