'use strict';
var app = require('../../server/server');
const VaGrit = require('va-grit-microservices');
var responseBuilder = require('va-grit-microservices/response/responseBuilder');

module.exports = function(Notification) {
  
  Notification.getNotifications = function(header, body, cb) {
       console.log("****Start of Notification.retrieveNotifications.  header: ", JSON.stringify(header));
       var response = responseBuilder.createResponseObject();
       var errorMessage;

       VaGrit.getUserFromToken(app, header, function (err, userId) {
          if (userId === undefined || userId === null){
             responseBuilder.setInvalidTokenStatus(response,header);
             cb(null,response);
          }
          else { // userId is defined
             console.log(' VaGrit.getUserFromToken userId: ', userId);
             //var notification = app.models.notification;

             // Retrieve the notifications for the userId
             // For now hardcodied for user 123, where we have dummy data imported
             app.models.notification.find({where: {vetId: userId}, fields: {vetId: false}},
                  function(err, results) {
                    if (err){
                      errorMessage = "notification.find for vetId [" + userId + "] resulted in an err" ;
                      console.log(errorMessage, err);
                      responseBuilder.setUnexpectedExceptionStatus(response,errorMessage);
                      cb(null,response);
                    }
                    else{
                      console.log("notification.find results:", results);
                      responseBuilder.setSuccessStatus(response);
                      response.payload.notifications = results;
                      console.log("Notification.retrieveNotifications. Response", response);
                      cb(null,response);
                    }
               });  // Notification.find

      } // else userId is defined

      });  // VaGrit.getUserFromToken

    };  // Notification.retrieveNotifications

    Notification.remoteMethod('getNotifications', {
        accepts: [
          {arg: 'Authorization', type: 'string', http: { source: 'header' }},
          { arg: 'data', type: 'object', http: { source: 'body' } }],
        returns: {arg: 'response', type: 'string'},
        http: {path: '/getNotifications', verb: 'post'}
    });
};
